
/*
 * Copyright (C) 2007 Dell Inc.
 * Chieng-Hwa Lin <chieng-hwa_lin@dell.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
//--------------------------------------------------------------------
// Defines to customize headers to follow
//--------------------------------------------------------------------

#if (!defined SYSTEM_DEBUG_LEVEL) && (defined _DEBUG)
#define SYSTEM_DEBUG_LEVEL      4
#endif

#define NUM_ADDRESS 300

#include <linux/version.h>

//#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,3)
//#define _LINUX_WAIT_H
//#endif
//--------------------------------------------------------------------
// chl// Linux include files
//--------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <linux/string.h>
#include <linux/errno.h>
//#include <linux/timer.h>
#include <linux/mtio.h>
#include <linux/ioctl.h>
#include <linux/unistd.h>
#include <string.h>
#include <linux/delay.h>
#include <linux/i2c-dev.h>
#define I2C_M_RD        0x01
//#include <asm/system.h>
//#include <linux/if.h>
#include <linux/if_ether.h>
#include <linux/sockios.h>

//--------------------------------------------------------------------
// Standard C include files
//--------------------------------------------------------------------
//#include <stdlib.h>
#include <stdio.h>

//--------------------------------------------------------------------
// Dell specific headers
//--------------------------------------------------------------------
#include "cmccfg_api.h"
/*
 * I2C Message - used for pure i2c transaction, also from /dev interface
 */
struct i2c_msg {
        __u16 addr;     /* slave address                        */
        __u16 flags;
#define I2C_M_TEN       0x10    /* we have a ten bit chip address       */
#define I2C_M_RD        0x01
#define I2C_M_NOSTART   0x4000
#define I2C_M_REV_DIR_ADDR      0x2000
#define I2C_M_IGNORE_NAK        0x1000
#define I2C_M_NO_RD_ACK         0x0800
        __u16 len;              /* msg length                           */
        __u8 *buf;              /* pointer to msg data                  */
};


//--------------------------------------------------------------------
// Shared include files
//--------------------------------------------------------------------
#include <linux/wait.h>
//--------------------------------------------------------------------
// Local definitions
//--------------------------------------------------------------------
#define CMC_HAPI_TEST_KEY               0x700000    
int privateSem;                                                 
int privateSem1;                                                 

//--------------------------------------------------------------------
// Prototypes
//--------------------------------------------------------------------
void ProcessI2CBusScan();
void ProcessStressTesting();
void DumpBuffer(unsigned char *buf, unsigned long len);
void ProcessReadGPIORegister();
void ProcessWriteGPIORegister();
void ProcessPPCi2cInfo();
void ProcessFanInfo();
void ProcessPowerSupplyInfo();
void ProcessTemperatureInfo();
void ProcessBladeControl();
void ProcessKVMFunctions();
void ProcessInterrupts();
void ProcessMiscFunctions();
void ProcessXilinxi2cInfo();
void ProcessWatchDogInfo();
void ProcessIOMInfo();
void ProcessI2CReset();
void ProcessI2CFPGACoreReset();
void ProcessStressTesting();
void ProcessCMCFRU();
void ReadCMCFRU();
void ReadCPFRU();
void ForceMidplaneRevision();
void driverstats(void);
//--------------------------------------------------------------------
// Local include files
// Function prototypes and other local includes
//--------------------------------------------------------------------
//#include <dcgpio.h>
#include <cmc_gpio.h>
#include <gpio_struct.h>
#include <gpioiocts.h>
#include <gtsupt.h>
#include <ppc_i2c_io.h>
#include <cmc_ppc_i2c_io_prototypes.h>
#include <cmc_gpio_prototypes.h>
#include <cmc_intr_prototypes.h>
#include <cmc_i2c_prototype.h>

char i2c_data[32768];
char i2c_data1[32768];


void DumpBuffer(unsigned char *buf, unsigned long len)
{
    unsigned long i, j, k;                                                 
    char buffer[80]; // 80 columns                                    
    char *hexstr = "0123456789ABCDEF";                                  
											
    for(i = 0; i < len; i+=16)                                          
    {                     
		// fill buffer with blanks
		memset(buffer, ' ', 78);
		// ASCIIZ termination
		buffer[78] = '\0';
		k = (16 < (len - i)) ? 16 : (len - i);
		for(j = 0; j < k; j++)                          
		{                                                               
			buffer[(j*3)] = hexstr[(buf[i + j] >> 4) & 0x0F];           
			buffer[(j*3) + 1] = hexstr[(buf[i + j]) & 0x0F];            
			buffer[j + 54] = ((buf[i + j] >= ' ') &&                    
			(buf[i + j] <= 'z')) ? buf[i + j] : '.';                
			if ((j > 0) && ((j % 4) == 0))
			{
				buffer[(j*3) - 1] = ':';                   
			}
		}                                                               
		printf("%s\n", buffer);
    }
} // DumpBuffer 


void ProcessReadGPIORegister()
{
	int base;
	int offset;
	int status;
	int result;
					printf("Read GPIO register:\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			// chl
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					status = CMCReadGpioData(base, offset, &result);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
					printf("result is 0x%x\n", result);
				}
					
					//ioperm(0xb1700010, 32, 0xffffffff);
					//in_info = inl((int)0xb1700010);
					//printf("inl result is 0x%x\n", in_info);
					printf("\n");
}

void ProcessWriteGPIORegister()
{
	int base;
	int offset;
	int status;
	int result;
	int current_value, new_value;
					printf("Write GPIO register:\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			// chl
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					status = CMCReadGpioData(base, offset, &result);
					if (status == 0)
					{
						printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
						printf("current value is 0x%x\n", result);
						current_value = result;
						printf("  Enter new value in Hex: ");
                				scanf("%x", &new_value);
						printf("  New value 0x%x entered\n",
							new_value);
						status = CMCWriteGpioData( base, offset, new_value); 
						if (status == 0)
						{
							printf("WRITE GPIO succeeded.\n");
						}
						else
						{
							printf("WRITE GPIO failed.\n");
						}
					}
					else
					{
						printf("READ GPIO ioctl failed.\n");
					}
					printf("\n");
}

void GPIOCmdMenu(GPIODeviceStruct *pGPIODevice)
{
	booln done = FALSE;
	booln done1 = FALSE;
	booln done2 = FALSE;
	int Cmd;
	int GPIOCmd;
	int base;
	int offset;
	int status;

        int c;
	int current_value, new_value, bitmask;
        char junk[80];
	int result;


	while(!done)
	{
		done1 = FALSE;
		done2 = FALSE;
		Cmd = 0;
		printf("\nDELL CMC Util Menu\n");
		printf("0 = Read GPIO register                 1 = Write GPIO register\n");
		printf("2 = PPC I2C operations                 3 = Fan Functions\n");
		printf("4 = Power Supply functions             5 = Temperature functions\n");
		printf("6 = CMC/Blade Control                  7 = KVM Functions\n");
		printf("8 = Interrupts                         9 = Misc Functions\n");
		printf("a = Xilinx I2c operations\n");
		printf("b = Read GPIO register (32 bits)       c = Write GPIO register (32 bits)\n");
		printf("d = Enable Hot Swap                    e = Watch Dog Functions\n");
		printf("f = IOM Functions                      g = i2c reset functions\n");
		//printf("h = I2C Bus Scan                       w = Stress Testing\n");
		printf("i = FPGA I2C Core Reset\n");
		printf("j = FRU operations\n");
		printf("k = Force midplane revision\n");
		printf("r = Core dump testing - will panic the system\n");
		printf("w = Stress Testing\n");
		// Make it invisible to users, debugging only
		//printf("z = HAPI semaphore release (testing only)\n");
		printf("x = exit\n");
		printf("Input Command Character - ");


                // chl
                scanf("%s", junk);
                Cmd = tolower(junk[0]);
                printf("\n");
		printf("\n\n");

		if(Cmd == 'x')
		{
			// if (kbhit() != 0)
                                getchar();  // make sure buffer is empty
			done = TRUE;
		}
		else
		{
			switch(Cmd)
			{
				case '0':
					ProcessReadGPIORegister();
				break;

				case '1':
					ProcessWriteGPIORegister();
				break;

				case '2':
					ProcessPPCi2cInfo();
				break;

				case '3':
					ProcessFanInfo();
				break;

				case '4':
					ProcessPowerSupplyInfo();
				break;

				case '5':
					ProcessTemperatureInfo();
				break;

				case '6':
					ProcessBladeControl();
				break;

				case '7':
					ProcessKVMFunctions();
				break;

				case '8':
					ProcessInterrupts();
				break;
				case '9':
					ProcessMiscFunctions();
				break;
				case 'a':
					ProcessXilinxi2cInfo();
				break;
				case 'b':
					printf("Read GPIO register (32 bit):\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			// chl
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					status = CMCReadGpioData32(base, offset, &result);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
					printf("result is 0x%x\n", result);
				}
				else
				{
					printf("IOCTL_GPIO_READ_CMD ioctl failed, status: 0x%x.\n", status);
				}
					
					//ioperm(0xb1700010, 32, 0xffffffff);
					//in_info = inl((int)0xb1700010);
					//printf("inl result is 0x%x\n", in_info);
					printf("\n");
				break;

				case 'c':
					printf("Write GPIO register (32 bit):\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			// chl
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					status = CMCReadGpioData32(base, offset, &result);
					if (status == 0)
					{
						printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
						printf("current value is 0x%x\n", result);
						current_value = result;
					}
					printf("  Enter new value in Hex: ");
                			scanf("%x", &new_value);
					printf("  New value 0x%x entered\n",
							new_value);
					printf("  Enter bit mask in Hex: ");
                			scanf("%x", &bitmask);
					printf("  Bit mask 0x%x entered\n",
							bitmask);
// Change request CR178748
					status =  CMCModifyGpioData32(base, offset, bitmask, new_value);
					if (status != 0)
					{
						printf("Modify GPIO ioctl failed, status: 0x%x.\n", status);
					}
#if 0
					status = CMCReadGpioData32(base, offset, &result);
					if (status == 0)
					{
						printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
						printf("current value is 0x%x\n", result);
						current_value = result;
						printf("  Enter new value in Hex: ");
                				scanf("%x", &new_value);
						printf("  New value 0x%x entered\n",
							new_value);
						status = CMCWriteGpioData32( base, offset, new_value); 
						if (status == 0)
						{
							printf("WRITE GPIO succeeded.\n");
						}
						else
						{
							printf("WRITE GPIO failed, status: 0x%x.\n", status);
						}
					}
					else
					{
						printf("READ GPIO ioctl failed, status: 0x%x.\n", status);
					}
#endif
					printf("\n");
				break;
				case 'd':
					printf("Enable Hot Swap:\n");
					status = CMCHotSwapEnable();
					if (status == CMC_STATUS_CMD_SUCCESS)
						printf("CMC hot swap is enabled.\n");
					else
						printf("Can't enabled CMC hot swap.\n");
				break;
				case 'e':
					printf("Watch Dog Functions:\n");
					ProcessWatchDogInfo();
				break;
				case 'f':
					printf("IOM Functions:\n");
					ProcessIOMInfo();
				break;
				case 'g':
					printf("I2C bus reset functions:\n");
					ProcessI2CReset();
				break;
				case 'h':
					printf("I2C bus scan:\n");
					ProcessI2CBusScan();
				break;
				case 'k':
					printf("Force midplane revision:\n");
					ForceMidplaneRevision();
				break;
				case 'i':
					printf("FPGA I2C bus core reset functions:\n");
					ProcessI2CFPGACoreReset();
				break;
				case 'w':
					printf("Stress Testing:\n");
					ProcessStressTesting();
				break;
				case 'j':
					printf("CMC FRU Operations:\n");
					ProcessCMCFRU();
				break;
				case 'r':
					printf("CMC Core Dump testing:\n");
					CMCSendIOCTLCmd(IOCTL_TESTING_CORE_DUMP);
				break;
				case 'n':
					GPIOCmd = 0;
					while (1)
					{
//					    if (kbhit() != 0)
//					    {
						    getchar();
						    break;
//					    }

					}
				break;
				case 'z':
					printf("Release HAPI semaphores (testing only):\n");
					ReleaseHAPISemaphores();
				break;

				default:
					GPIOCmd = 999;
			} // switch cmd
                        // chl, clean the stdin buffer
                        c = fgetc (stdin);
		}
                if (!done)
                {
                        // chl, clean the stdin buffer
                        while(c != '\n')
                                c = fgetc (stdin);

                        printf("\nPress ENTER to continue...\n");
                        getchar();
                }
	} // while(!done) 

}//GPIOCmdMenu

void ForceMidplaneRevision()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];
	int rc;

    while(!done1)
    {
	junk[0] = '0';
	if (rc = cfgGetByName(CMCCFG_DEFAULT_WAIT, CMCCFG_RETRIES(5),
			"CHASSIS_BLADE_forcemidplane", junk, sizeof(junk)))
		printf("cfgGetByName failed, rc=0x%x\n", rc);

	printf("\nForce midplane revision (current state is %s):\n",
		junk[0] == '1' ? "on" : "off");
	printf("0 = clear force midplane revision\n");
	printf("1 = force midplane revision to 1.1\n");
	printf("x = exit\n\n");
	printf("WARNING: cmc reboot is required to apply any changes.\n\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				if (rc = cfgSetByName(CMCCFG_DEFAULT_WAIT, CMCCFG_RETRIES(5),
						"CHASSIS_BLADE_forcemidplane", "0"))
					printf("cfgSetByName failed, rc=0x%x\n", rc);
				printf("\n");
			break;
			case '1':
				if (rc = cfgSetByName(CMCCFG_DEFAULT_WAIT, CMCCFG_RETRIES(5),
						"CHASSIS_BLADE_forcemidplane", "1"))
					printf("cfgSetByName failed, rc=0x%x\n", rc);
				printf("\n");
			break;
		}
	}
    }
}

void ProcessI2CFPGACoreReset()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];

    while(!done1)
    {
	printf("\nCMC FPGA I2C Bus Core Reset Functions:\n");
	printf("0 = Reset IOM 1              1 = Reset IOM 2\n");
	printf("2 = Reset PSU 1              3 = Reset PSU 2\n");
	printf("4 = Reset KVM\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Reset IOM 1 Bus:\n");
					status = CMCResetI2CCoreIOM1Bus();
					if (status == 0)
							printf("IOM 1 bus is reset.\n");
					else
					   printf("Can't reset IOM bus 1, status: 0x%x\n", status);
					printf("\n");
			break;
			case '1':
					printf("Reset IOM 2 Bus:\n");
					status = CMCResetI2CCoreIOM2Bus();
					if (status == 0)
							printf("IOM 2 bus is reset.\n");
					else
					   printf("Can't reset IOM bus 2, status: 0x%x\n", status);
					printf("\n");
			break;
			case '2':
					printf("Reset PSU 1 Bus:\n");
					status = CMCResetI2CCorePSU1Bus();
					if (status == 0)
							printf("PSU 1 bus is reset.\n");
					else
					   printf("Can't reset PSU 1 bus, status: 0x%x\n", status);
					printf("\n");
			break;
			case '3':
					printf("Reset PSU 2 Bus:\n");
					status = CMCResetI2CCorePSU2Bus();
					if (status == 0)
							printf("PSU 2 bus is reset.\n");
					else
					   printf("Can't reset PSU 2 bus, status: 0x%x\n", status);
					printf("\n");
			break;
			case '4':
					printf("Reset KVM Bus:\n");
					status = CMCResetI2CCoreKVMBus();
					if (status == 0)
							printf("KVM bus is reset.\n");
					else
					   printf("Can't reset KVM bus, status: 0x%x\n", status);
					printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessI2CReset()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];

    while(!done1)
    {
	printf("\nCMC I2C Bus Reset Functions:\n");
	printf("0 = Reset IOM 1              1 = Reset IOM 2\n");
	printf("2 = Reset PSU 1              3 = Reset PSU 2\n");
	printf("4 = Reset KVM\n");
	printf("5 = Reset PPC Bus 0          6 = Reset PPC Bus 1\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Reset IOM 1 Bus:\n");
					status = CMCResetI2CIOM1Bus();
					if (status == 0)
							printf("IOM 1 bus is reset.\n");
					else
					   printf("Can't reset IOM bus 1, status: 0x%x\n", status);
					printf("\n");
			break;
			case '1':
					printf("Reset IOM 2 Bus:\n");
					status = CMCResetI2CIOM2Bus();
					if (status == 0)
							printf("IOM 2 bus is reset.\n");
					else
					   printf("Can't reset IOM bus 2, status: 0x%x\n", status);
					printf("\n");
			break;
			case '2':
					printf("Reset PSU 1 Bus:\n");
					status = CMCResetI2CPSU1Bus();
					if (status == 0)
							printf("PSU 1 bus is reset.\n");
					else
					   printf("Can't reset PSU 1 bus, status: 0x%x\n", status);
					printf("\n");
			break;
			case '3':
					printf("Reset PSU 2 Bus:\n");
					status = CMCResetI2CPSU2Bus();
					if (status == 0)
							printf("PSU 2 bus is reset.\n");
					else
					   printf("Can't reset PSU 2 bus, status: 0x%x\n", status);
					printf("\n");
			break;
			case '4':
					printf("Reset KVM Bus:\n");
					status = CMCResetI2CKVMBus();
					if (status == 0)
							printf("KVM bus is reset.\n");
					else
					   printf("Can't reset KVM bus, status: 0x%x\n", status);
					printf("\n");
			break;
			case '5':
					printf("Reset PPC Bus 0:\n");
					status = CMCResetI2CPPC0Bus();
					if (status == 0)
							printf("PPC bus 0 is reset.\n");
					else
					   printf("Can't reset PPC bus 0, status: 0x%x\n", status);
					printf("\n");
			break;
			case '6':
					printf("Reset PPC Bus 1:\n");
					status = CMCResetI2CPPC1Bus();
					if (status == 0)
							printf("PPC bus 1 is reset.\n");
					else
					   printf("Can't reset PPC bus 1, status: 0x%x\n", status);
					printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessIOMInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];
	int Temp;

    while(!done1)
    {
	printf("\nCMC Watch Dog Functions:\n");
	printf("0 = Read IOM Module Present bit map           1 = Read IOM Blank Module bit map\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Read IOM Module bit map:\n");
					status = CMCReadIOModulePresentBitMap(&Temp);
					if (status == 0)
					{
							printf("IOM Module present bit map: 0x%x.\n", Temp);
					}
					else
					   printf("Can't read IOM module present bit map: 0x%x\n", status);
					printf("\n");
			break;
			case '1':
					printf("Read IOM Blank Module bit map:\n");
					status = CMCReadIOModuleBlankPresentBitMap(&Temp);
					if (status == 0)
					{
							printf("IOM Blank Module present bit map: 0x%x.\n", Temp);
					}
					else
					   printf("Can't read IOM blank module present bit map: 0x%x\n", status);
					printf("\n");
			break;
		    } // While done1
		}
	}
}


void ProcessWatchDogInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
        char junk[80];
	int Temp;

    while(!done1)
    {
	printf("\nCMC Watch Dog Functions:\n");
	printf("0 = Arm/Disarm Watch Dog               1 = Reset Watch Dog\n");
	printf("2 = Clear Watch Dog Latch              3 = Set Watch Dog Timer Duration\n");
	printf("4 = Read Watch Dog Timer Duration      5 = Read Watch Dog Timer State\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Arm/Disarm Watch Dog:\n");
					printf("  Option (1: Arm, 0: Disarm ): ");
                			scanf("%d", &Temp);
					status = CMCWatchDogArmDisarm(Temp);
					if (status == 0)
					{
						if (Temp == 1)
							printf("Watch dog is armed.\n");
						else
							printf("Watch dog is disarmed.\n");
					}
					else
					   printf("cwWatch Dog error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '1':
					printf("Reset Watch Dog:\n");
					status = CMCWatchDogReset();
					if (status == 0)
					{
						printf("Watch dog is reset.\n");
					}
					else
					   printf("Watch reset error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '2':
					printf("Clear Watch Latch:\n");
					status = CMCWatchDogClearLatch();
					if (status == 0)
					{
						printf("Watch latch is cleared.\n");
					}
					else
					   printf("Watch latch clear error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '3':
					printf("Set Watch Dog Timer Duration:\n");
					printf("  Duration(seconds): ");
                			scanf("%d", &Temp);
					Temp = Temp * 1000;
					status = CMCSetWatchDogTimerDuration(Temp);
					if (status == 0)
					{
						printf("Watch Dog Timer Duration is set to %d.\n", Temp);
					}
					else
					   printf("Can't set wtach dog timer duration, status: 0x%x\n", status);
					printf("\n");
			break;
			case '4':
					printf("Read Watch Dog Timer Duration:\n");
					status = CMCReadWatchDogTimerDuration(&Temp);
					if (status == 0)
					{
						Temp = Temp/1000;
						printf("Watch Dog Timer Duration :  %d seconds.\n", Temp);
					}
					else
					   printf("Can't read wtach dog timer duration, status: 0x%x\n", status);
					printf("\n");
			break;
			case '5':
					printf("Read Watch Dog Timer State:\n");
					status = CMCReadWatchDogTimerState(&Temp);
					if (status == 0)
					{
						if (Temp == CMC_WDT_EVENT_NOT_OCCURRED)
							printf("Watch dog event not occurred.\n");
						else
							printf("Watch dog event occurred.\n");
					}
					else
					   printf("Watch Dog error, status: 0x%x\n", status);
					printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessXilinxi2cInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	int i;
        char junk[80];
	int pattern;
	struct i2c_rdwr_ioctl_data msgset;
	char buf1[4];
	char buf2[4];
	struct i2c_msg *i2c_msg_ptr;

    while(!done1)
    {
	printf("\nCMC Power PPC I2C Operations:\n");
	printf("0 = Read Xilinx I2C IOM 1 register     1 = Write Xilinx I2C IOM 1 register\n");
	printf("2 = Read Xilinx I2C IOM 2 register     3 = Write Xilinx I2C IOM 2 register\n");
	printf("4 = Read Xilinx I2C PSU 1 register     5 = Write Xilinx I2C PSU 1 register\n");
	printf("6 = Read Xilinx I2C PSU 2 register     7 = Write Xilinx I2C PSU 2 register\n");
	printf("8 = Read Xilinx I2C KVM register       9 = Write Xilinx I2C KVM register\n");
	printf("a = Xilinx I2C IOM repeated I/O\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Read Xilinx I2C IOM 1 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCReadXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else 
						status = CMCReadXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
						//status = CMCReadXilinxI2CIOM1Data(base, offset, i2c_length, i2c_data);
					if (status == 0)
					   DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
					   printf("I2c error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '1':
					printf("Write Xilinx I2C IOM 1 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					memset(i2c_data, pattern, 32768);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
					if (status != 0)
				   	  		printf("I2c write error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '2':
					printf("Read Xilinx I2C IOM 2 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCReadXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCReadXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
					if (status == 0)
					   DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
					   printf("I2c error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '3':
					printf("Write Xilinx I2C IOM 2 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					memset(i2c_data, pattern, 32768);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
						if (status != 0)
					   	  printf("I2c write error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '4':
					printf("Read Xilinx I2C PSU 1 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					status = CMCReadXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
					if (status == 0)
					   DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
					   printf("I2c error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '5':
					printf("Write Xilinx I2C PSU 1 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					memset(i2c_data, pattern, 32768);
						status = CMCWriteXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
						if (status != 0)
					   	  printf("I2c write error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '6':
					printf("Read Xilinx I2C PSU 2 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					status = CMCReadXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data);
					if (status == 0)
					   DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
					   printf("I2c error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '7':
					printf("Write Xilinx I2C PSU 2 register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					memset(i2c_data, pattern, 32768);
						status = CMCWriteXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
						if (status != 0)
					   	  printf("I2c write error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '8':
					printf("Read Xilinx I2C KVM register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
						status = CMCReadXilinxI2CKVMData(base, offset, i2c_length, i2c_data);
						if (status == 0)
					   	DumpBuffer((unsigned char *)i2c_data, i2c_length);
						else
					   	printf("I2c error, status: 0x%x\n", status);
					printf("\n");
			break;
			case '9':
					printf("Write Xilinx I2C KVM register:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					memset(i2c_data, pattern, 32768);
						status = CMCWriteXilinxI2CKVMData (base, offset, i2c_length, i2c_data);
						if (status != 0)
					   	  printf("I2c write error, status: 0x%x\n", status);
					printf("\n");
			break;
			case 'a':
				printf("Xilinx I2C IOM register repeated I/O:\n");

				for ( i = 0; ; i++)

				{
					i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
					// I2c offset
					memset(buf1, 0x00, 1);
					buf1[0] = 0;
					buf1[1] = 0;
					i2c_msg_ptr[0].addr = 0xa0 >> 1;
					i2c_msg_ptr[0].flags = 0;
					i2c_msg_ptr[0].len = 2;
					i2c_msg_ptr[0].buf = buf1;
				
					// I2c Read	
					memset(buf1, 0xee, 4);
					i2c_msg_ptr[1].addr = 0xa0 >> 1;
					i2c_msg_ptr[1].flags = I2C_M_RD;
					i2c_msg_ptr[1].len = 4;
					i2c_msg_ptr[1].buf = buf2;
					msgset.msgs = i2c_msg_ptr;
					msgset.nmsgs = 2;
					status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_IOM1_I2C, &msgset);
					if (status != 0)
			   	  		printf("I2c write error, status: 0x%x\n", status);
					else
				  		DumpBuffer((unsigned char *)buf2, 4);
					free(i2c_msg_ptr);
				}
				printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessPPCi2cInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status = 0;
	int base;
	int offset;
	int i2c_length;
	int  value;
	int temp;
	char temp1;
	short temp2;
        char junk[80];
	int pattern;

    while(!done1)
    {
	printf("\nCMC Power PPC I2C Operations:\n");
	printf("0 = Read PPC I2C Bus 0 register        1 = Write PPC I2C Bus 0 rgister\n");
	printf("2 = Read PPC I2C Bus 1 register        3 = Write PPC I2C Bus 1 rgister\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("Read PPC I2C register on bus 0:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					status = read_ppc_i2c_bus0_data(base, offset, i2c_length, i2c_data);
					if (status == 0)
						DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
						printf("Can't read the data for ppc bus 0.\n");
					printf("\n");
			break;
			case '1':
					printf("Write PPC I2C register on bus 0:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
try_again_i2c1:
					printf("Writing byte or word (1: byte, 2: word, 3: buffer)\n");
                			scanf("%x", &temp);
					if ( (temp < 0) || (temp > 3) )
						goto try_again_i2c1;
					if (temp == 1)
					{
						printf("  Enter I2C data (byte) in hex: ");
                				// chl
                				scanf("%x", &value);
						printf("  I2C data 0x%x entered\n",
							value);
						temp1 = value;
						status = write_ppc_i2c_bus0_data(base, offset, 1, &temp1);
					}
					else if (temp == 2)
					{
						printf("  Enter I2C data (word) in hex: ");
                				// chl
                				scanf("%x", &value);
						printf("  I2C data 0x%x entered\n",
							value);
						temp2 = value;
						status = write_ppc_i2c_bus0_data(base, offset, 2, (char *)&temp2);
					} else if (temp == 3)
					{
						printf("  Enter write pattern in hex: ");
                				// chl
                				scanf("%x", &pattern);
						printf("  I2C pattern: 0x%x entered\n",
						pattern);
						printf("  Enter length in decimal: ");
                				// chl
                				scanf("%d", &i2c_length);
						memset(i2c_data, pattern, 32768);
						status = write_ppc_i2c_bus0_data(base, offset, i2c_length, i2c_data);
					} 
					if (status != 0)
						printf("  Can't write to PPC bus 0, status: 0x%x\n", status);
					printf("\n");
			break;
			case '2':
					printf("Read PPC I2C register on bus 1:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					if ( (base ==  PPC_I2C_CP_FRU_1) || 
						(base ==  PPC_I2C_CP_FRU_2))
						status = read_ppc_i2c_bus1_data_word(base, offset, i2c_length, i2c_data);
					else
						status = read_ppc_i2c_bus1_data(base, offset, i2c_length, i2c_data);
			
					if (status == 0)
						DumpBuffer((unsigned char *)i2c_data, i2c_length);
					else
						printf("Can't read the data for ppc bus 1.\n");
					printf("\n");
			break;
			case '3':
					printf("Write PPC I2C register on bus 1:\n");
					printf("  Enter I2C base address(default: 0xA8): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
try_again_i2c2:
					printf("Writing byte or word (1: byte, 2: word, 3: buffer)\n");
                			scanf("%x", &temp);
					if ( (temp < 0) || (temp > 3) )
						goto try_again_i2c2;
					if (temp == 1)
					{
						printf("  Enter I2C data (byte) in hex: ");
                				// chl
                				scanf("%x", &value);
						printf("  I2C data 0x%x entered\n",
							value);
						temp1 = value;
						if ( (base ==  PPC_I2C_CP_FRU_1) || 
							(base ==  PPC_I2C_CP_FRU_2))
							status = write_ppc_i2c_bus1_data_word(base, offset, 1, &temp1);
						else
						 	status = write_ppc_i2c_bus1_data(base, offset, 1, &temp1);
					}
					else if (temp == 2)
					{
						printf("  Enter I2C data (word) in hex: ");
                				// chl
                				scanf("%x", &value);
						printf("  I2C data 0x%x entered\n",
							value);
						temp2 = value;
						if ( (base ==  PPC_I2C_CP_FRU_1) || 
							(base ==  PPC_I2C_CP_FRU_2))
							status = write_ppc_i2c_bus1_data_word(base, offset, 2, (char *)&temp2);
						else
						 	status = write_ppc_i2c_bus1_data(base, offset, 2, (char *)&temp2);
					} else if (temp == 3)
					{
						printf("  Enter write pattern in hex: ");
                				// chl
                				scanf("%x", &pattern);
						printf("  I2C pattern: 0x%x entered\n",
						pattern);
						printf("  Enter length in decimal: ");
                				// chl
                				scanf("%d", &i2c_length);
						memset(i2c_data, pattern, 32768);
						if ( (base ==  PPC_I2C_CP_FRU_1) || 
							(base ==  PPC_I2C_CP_FRU_2))
							status = write_ppc_i2c_bus1_data_word(base, offset, i2c_length, i2c_data);
						else
						 	status = write_ppc_i2c_bus1_data(base, offset, i2c_length, i2c_data);
					} 

// Old code starts here
#ifdef chl
					printf("Writing byte or word (1: byte, 2: word)\n");
                			scanf("%x", &temp);
					if ( (temp < 0) || (temp > 2) )
						goto try_again_i2c2;
					if (temp == 1)
						printf("  Enter I2C data (byte) in hex: ");
					else
						printf("  Enter I2C data (word) in hex: ");
                			// chl
                			scanf("%x", &value);
					printf("  I2C data 0x%x entered\n",
						value);
					if ( (base ==  PPC_I2C_CP_FRU_1) || 
						(base ==  PPC_I2C_CP_FRU_2))
					{
						if (temp == 1)
						{
							temp1 = value;
							status = write_ppc_i2c_bus1_data_word(base, offset, 1, &temp1);
						}
						else
						{
							temp2 = value;
							status = write_ppc_i2c_bus1_data_word(base, offset, 2, &temp2);
						}
					}
					else
					{
						if (temp == 1)
						{
							temp1 = value;
							status = write_ppc_i2c_bus1_data(base, offset, 1, &temp1);		}
						else
						{
							temp2 = value;
							status =  write_ppc_i2c_bus1_data(base, offset, 2, &temp2);		}
					}
#endif // chl
					if (status != 0)
						printf("  Can't write to PPC bus 1, status: 0x%x\n", status);
					printf("\n");
			break;
			case '4':
			break;
			case '5':
			break;
			case '6':
			break;
		    } // While done1
		}
	}
}
void ProcessFanInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

	int fan_number, fan_speed, fan_threshold;
	int FanStateLED;
	int fan_ct_threshold;
        char junk[80];
	int fan_module_number;
	int duty_cycle;
	int i, j;
	CMCFanConfigurationInfo CMCFanInfo;

    while(!done1)
    {
	printf("\nCMC Fan Operations:\n");
	printf("0 = Read Fan Configuration             1 = Read Fan Speed\n");
	printf("2 = Change Fan PWM                     3 = Read Fan Critical Threshold\n");
	printf("4 = Write Fan Critical Threshold       5 = Write Fan State LED\n");
	printf("6 = Read Fan State LED                 7 = Read Fan PWM\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				status = CMCReadFanConfiguration(&CMCFanInfo);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("CMC Fan Configuration: \n");
					if (CMCFanInfo.NumberOfFans == 1)
						printf("  There is %d fan in the system.\n", CMCFanInfo.NumberOfFans); 
					else
						printf("  There are %d fans in the system.\n", CMCFanInfo.NumberOfFans);
					printf("  CMC Fan Present Bit Mask: 0x%x\n", CMCFanInfo.FanPresentMask);
					printf("  Fan Configuration : 0x%x\n", CMCFanInfo.FanConfigurationSupport);					
					printf("\n");
					for ( i = 0, j =1; i < CMC_MAX_FAN_MODULE_NUMBER; i++, j++)
					{
						printf("  Fan number %d Fan type: %d\n", j, CMCFanInfo.FanConfiguration[i].FanType);
					}
				}
				else
				{
					printf("CMC Fan Configuration is not supported yet.\n");
				}
					printf("\n");
				printf("\n");
			break;
			case '1':
				printf("Read Fan Speed:\n");
				printf("  Enter fan number in decimal ( 1- 18, Fan 2/Rotor 2 = Fan 4) : ");
       				scanf("%d", &fan_number);
		 		status = CMCReadFanSpeed(fan_number, &fan_speed);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan speed for fan %d: %d\n", fan_number, fan_speed );
				}
				else
				{
					if (status == CMC_STATUS_CMD_NO_SUCH_DEVICE)
			  			printf("  Invalid fan number entered. status: 0x%x.\n", status);
					else if (status == CMC_STATUS_GPIO_DATA_NOT_AVAILBLE )
			  			printf("  Fan speed is not availble.\n");
					else
			  			printf("  Couldn't read the fan speed, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '2':
				printf("Change Fan Speed:\n");
fan_input:
				printf("  Enter fan module number in decimal( 1- 9): ");
                		scanf("%d", &fan_module_number);
				if ( (fan_module_number < 1) || (fan_module_number >9) ) 
				{
					printf("  Invalid fan module number. Please enter again.\n");
					goto fan_input;
				}
duty_input:
				printf("  Enter the duty cycle (i.e. 100 is the highest speed): ");
                		scanf("%d", &duty_cycle);
				if ( (duty_cycle < 1) || (duty_cycle >100) ) 
				{
					printf("  Invalid duty cycle number. Please enter again.\n");
					goto duty_input;
				}
				status = CMCWriteFanPWM(fan_module_number, duty_cycle);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan speed for fan module %d is changed to %d percent.\n", fan_module_number, duty_cycle );
				}
				else
				{
					if (status == CMC_STATUS_CMD_NO_SUCH_DEVICE)
			 			printf("  Invalid fan module number entered. status: 0x%x.\n", status);
					else
					{
						if (status == CMC_STATUS_CMD_INVALID_PARAMETER)
				
						printf("  Invalid duty cycle entered. status: 0x%x.\n", status);
						else
						  				printf("  Couldn't set the fan speed, status: 0x%x.\n", status);
					}
				}
				printf("\n");
			break;
			case '3':
				printf("Read Fan Critical Threshold:\n");
				printf("  Enter fan number in decimal ( 1- 18, Fan 2/Rotor 2 = Fan 4) : ");
                		scanf("%d", &fan_number);
		 		status = CMCReadFanCTThreshold(fan_number, &fan_ct_threshold);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan threshold for fan %d: %d\n", fan_number, fan_ct_threshold );
				}
				else
				{
					if (status == CMC_STATUS_CMD_NO_SUCH_DEVICE)
			  			printf("  Invalid fan number entered. status: 0x%x.\n", status);
					else if (status == CMC_STATUS_GPIO_DATA_NOT_AVAILBLE )
			  			printf("  Fan threshold is not availble.\n");
					else
			  			printf("  Couldn't read the fan speed, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '4':
				printf("Write Fan Critical threshold:\n");
fan_input_1:
				printf("  Enter fan number in decimal ( 1- 18, Fan 2/Rotor 2 = Fan 4) : ");
                		scanf("%d", &fan_number);
				if ( (fan_number < 1) || (fan_number >18) ) 
				{
					printf("  Invalid fan number. Please enter again.\n");
					goto fan_input_1;
				}
fan_input_2:
				printf("  Enter the threshold: ");
                		scanf("%d", &fan_threshold);
				if (fan_threshold < 0) 
				{
					printf("  Invalid threshold number. Please enter again.\n");
					goto fan_input_2;
				}
				status = CMCWriteFanCTThreshold(fan_number, fan_threshold);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan critical threshold for fan %d is changed to %d RPM.\n", fan_number, fan_threshold );
				}
				else
				{
			  		printf("  Couldn't set the fan fan threshold, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '5':
				printf("Write Fan State LED:\n");
fan_input_3:
				printf("  Enter fan module number in decimal( 1- 9): ");
                		scanf("%d", &fan_module_number);
				if ( (fan_module_number < 1) || (fan_module_number >9) ) 
				{
					printf("  Invalid fan number. Please enter again.\n");
					goto fan_input_3;
				}
				printf("  Fan State LED Options:\n");
				printf("  0 = Chassis Power Off - Both LEDs off\n");
				printf("  1 = Fan module good - LED1 on, LED2 off\n");
				printf("  2 = Fan module fault - LED1 off, LED2 on\n");
				printf("  3 = Fan1 fail - LED1 off, LED2 blink pattern 1\n");
				printf("  4 = Fan2 fail - LED1 off, LED2 blink pattern 2\n");
				printf("  5 = Fan 1 and fan2 fail - LED1 off, LED2 blink pattern 3\n");
fan_input_4:
				printf("  Enter the fan state LED(0 -5): ");
                		scanf("%d", &FanStateLED);
				if ((FanStateLED < 0) || (FanStateLED > 5)) 
				{
					printf("  Invalid fan state LED. Please enter again.\n");
					goto fan_input_4;
				}
				status = CMCWriteFanStateLED(fan_module_number, FanStateLED);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan state LED for fan module %d is changed to %d.\n", fan_module_number, FanStateLED );
				}
				else
				{
			  		printf("  Couldn't set the fan state  LED, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '6':
				printf("Read Fan State LED:\n");
fan_input_5:
				printf("  Enter fan module number in decimal( 1- 9): ");
                		scanf("%d", &fan_module_number);
				if ( (fan_module_number < 1) || (fan_module_number >9) ) 
				{
					printf("  Invalid fan number. Please enter again.\n");
					goto fan_input_5;
				}
				status = CMCReadFanStateLED(fan_module_number, &FanStateLED);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan state LED for fan module %d is %d.\n", fan_module_number, FanStateLED );
				}
				else
				{
			  		printf("  Couldn't read the fan state  LED, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '7':
				printf("Read Fan PWM:\n");
fan_input_8:
				printf("  Enter fan module number in decimal( 1- 9): ");
                		scanf("%d", &fan_module_number);
				if ( (fan_module_number < 1) || (fan_module_number >9) ) 
				{
					printf("  Invalid fan number. Please enter again.\n");
					goto fan_input_8;
				}
				status = CMCReadFanPWM(fan_module_number, &FanStateLED);
				if (status == CMC_STATUS_CMD_SUCCESS)
				{
					printf("  The fan PWM for fan module %d is %d.\n", fan_module_number, FanStateLED );
				}
				else
				{
			  		printf("  Couldn't read the fan PWM, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessPowerSupplyInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

        char junk[80];
	int NumberOfPowerSupply;
	int PowerSupplyBitMap;
	int CMCPowerSupplyACStatusBitMap;
	int PS_on_off_option;
	int PS_bit_map;
	int temp;
	int PowerSupplyOnOffStatus;
	int PowerSupplyStatus;

    while(!done1)
    {
	printf("\nCMC Power Supply Functions:\n");
	printf("0 = Read Power Supply Configuration    1 = Read Power Supply Status\n");
	printf("2 = Turn Power Supply On/Off           3 = Read Power Supply On/Off Status\n");
	printf("4 = Turn Blade PS On/Off\n");
	printf("5 = Read PSU Subject Input Value Register\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("CMC Power Supply Configuration: \n");
				                                               
				NumberOfPowerSupply = CMCNumberOfPowerSupplyInTheSystem();
				printf("  There are %d power supplies in the system.\n", NumberOfPowerSupply);
				status = CMCGetPSPresentBitMap(&PowerSupplyBitMap);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Power supply bit map: 0x%x.\n", PowerSupplyBitMap);
				else
				  printf("  Couldn't read power supply bit map, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '1':
				printf("CMC Power Supply Status: \n");
				status = CMCReadAllPSACStatus(&CMCPowerSupplyACStatusBitMap);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Power supply AC status bit map: 0x%x.\n", CMCPowerSupplyACStatusBitMap);
				else
				  printf("  Couldn't read power supply AC status, status: 0x%x.\n", status);
				status = CMCReadAllPSDCStatus(&CMCPowerSupplyACStatusBitMap);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Power supply DC status bit map: 0x%x.\n", CMCPowerSupplyACStatusBitMap);
				else
				  printf("  Couldn't read power supply DC status, status: 0x%x.\n", status);
			break;
			case '2':
				printf("Turn Power Supply On/Off: \n");
fan_input_6:
				printf("  Option (1: on, 2: off ): ");
                		scanf("%d", &PS_on_off_option);
				if ( (PS_on_off_option < 1) || (PS_on_off_option >2) ) 
				{
					printf("  Invalid option. Please enter again.\n");
					goto fan_input_6;
				}
				if (PS_on_off_option == 1)
				{
					printf("  Enter PS bit map in Hex (0x3f = all on): ");
                			scanf("%x", &PS_bit_map);
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_ON);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned on\n", PS_bit_map);
					else
				  		printf("  Couldn't turn on the power supply, status: 0x%x.\n", status);
				}
				else
				{
					printf("  Enter PS bit map in Hex (0x3f = all off): ");
                			scanf("%x", &PS_bit_map);
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_OFF);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned off\n", PS_bit_map);
					else
				  		printf("  Couldn't turn off the power supply, status: 0x%x.\n", status);
				}
			break;
			case '3':
				printf("Read Power Supply On/Off Status: \n");
				status = CMCReadPSOnOffStatus(&PowerSupplyOnOffStatus);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
			  		printf("  Power supplies on/off status (bit map): 0x%x.\n", PowerSupplyOnOffStatus);
				else
			  		printf("  Couldn't read the power supply on/off status, status: 0x%x.\n", status);
			break;
			case '4':
				printf("Turn Blade Power Supply On/Off: \n");
				printf("  Option (1: on, 2: off ): ");
                		scanf("%d", &PS_on_off_option);
				if ( (PS_on_off_option < 1) || (PS_on_off_option >2) ) 
				{
					printf("  Invalid option. Please enter again.\n");
					goto fan_input_6;
				}
				if (PS_on_off_option == 1)
				{
					printf("  Enter PS bit map in Hex (0xffff = all on): ");
                			scanf("%x", &PS_bit_map);
					status = CMCTurnBladePSOnOff(PS_bit_map, CMC_TURN_PS_ON);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Blade Power supplies (bit map): 0x%x. have been turned on\n", PS_bit_map);
					else
				  		printf("  Couldn't turn on the blade power supply, status: 0x%x.\n", status);
				}
				else
				{
					printf("  Enter PS bit map in Hex (0xffff = all off): ");
                			scanf("%x", &PS_bit_map);
					status = CMCTurnBladePSOnOff(PS_bit_map, CMC_TURN_PS_OFF);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Blade Power supplies (bit map): 0x%x. have been turned off\n", PS_bit_map);
					else
				  		printf("  Couldn't turn off the blade power supply, status: 0x%x.\n", status);
				}
			break;
			case '5':
				printf("Read PSU Subject Input Value Register: \n");
				printf("  Enter power supply number: ");
                		scanf("%d", &temp);
				status = CMCReadPSUSubjectInputValueRegister(temp, &PowerSupplyStatus);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
			  		printf("  PSU subject input register: 0x%x.\n", PowerSupplyStatus);
				else
			  		printf("  Couldn't read the PSU subject input register, status: 0x%x.\n", status);
			break;
		    } // While done1
		}
	}
}


void ProcessTemperatureInfo()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

        char junk[80];
	int TemperatureTemp;
	int TemperatureTemp1;
	int CPUTempThresholdLow;
	int CPUTempThresholdHi;

    while(!done1)
    {
	printf("\nCMC Temperature Functions:\n");
	printf("0 = Read CMC Temperature                  1 = Read CP Temperature\n");
	printf("2 = Read CMC Temperature Thresholds       3 = Read CP Temperature Thresholds\n");
	printf("4 = Set CMC Temperature Thresholds        5 = Set CP Temperature Thresholds\n");
	printf("6 = Read CPU Temperature                  7 = Read CPU Temperature Thresholds\n");
	printf("8 = Set CPU Temperature Thresholds\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("Read CMC Temperature: \n");
				                                               
				status = CMCReadCMCTemperature(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Temperature (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CMC temperature, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '1':
				printf("Read CP Temperature: \n");
				                                               
				status = CMCReadCPTemperature(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CP Temperature (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CP temperature, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '2':
				printf("Read CMC Temperature Thresholds: \n");
				                                               
				status = CMCReadCMCTemperatureLowThreshold(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Temperature low threshold (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CMC temperature low threshold, status: 0x%x.\n", status);
				status = CMCReadCMCTemperatureHiThreshold(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Temperature high threshold (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CMC temperature high threshold, status: 0x%x.\n", status);
				printf("\n");
				printf("\n");
			break;
			case '3':
				printf("Read CP Temperature Thresholds: \n");
				                                               
				status = CMCReadCPTemperatureLowThreshold(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CP Temperature low threshold (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CP temperature low threshold, status: 0x%x.\n", status);
				status = CMCReadCPTemperatureHiThreshold(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CP Temperature high threshold (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CP temperature high threshold, status: 0x%x.\n", status);
				printf("\n");
				printf("\n");
			break;
			case '4':
				printf("Set CMC Temperature Thresholds: \n");
				printf("  Low threshold: ");
                		scanf("%d", &TemperatureTemp);
				printf("  High threshold: ");
                		scanf("%d", &TemperatureTemp1);
				                                               
				status = CMCSetCMCTemperatureLowThreshold(TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Temperature low threshold (in centigrade) is set to: %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't set CMC temperature low threshold, status: 0x%x.\n", status);
				status = CMCSetCMCTemperatureHiThreshold(TemperatureTemp1);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Temperature high threshold (in centigrade) is set to: %d.\n", TemperatureTemp1);
				else
				  printf("  Couldn't set CMC temperature hi threshold, status: 0x%x.\n", status);
				printf("\n");
				printf("\n");
			break;
			case '5':
				printf("Set CP Temperature Thresholds: \n");
				printf("  Low threshold: ");
                		scanf("%d", &TemperatureTemp);
				printf("  High threshold: ");
                		scanf("%d", &TemperatureTemp1);
				                                               
				status = CMCSetCPTemperatureLowThreshold(TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CP Temperature low threshold (in centigrade) is set to: %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't set CP temperature low threshold, status: 0x%x.\n", status);
				status = CMCSetCPTemperatureHiThreshold(TemperatureTemp1);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CP Temperature high threshold (in centigrade) is set to: %d.\n", TemperatureTemp1);
				else
				  printf("  Couldn't set CP temperature hi threshold, status: 0x%x.\n", status);
				printf("\n");
				printf("\n");
			break;
			case '6':
				printf("Read CPU Temperature: \n");
				                                               
				status = CMCReadCPUTemperature(&TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CPU Temperature (in centigrade): %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't read CPU temperature, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '7':
				printf("Read CPU Temperature Thresholds: \n");
				                                               
				status = CMCReadCPUTemperatureLowThreshold(&CPUTempThresholdLow);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CPU Temperature low threshold (in centigrade): %d.\n", CPUTempThresholdLow);
				else
				  printf("  Couldn't read CPU temperature low threshold, status: 0x%x.\n", status);
				status = CMCReadCPUTemperatureHiThreshold(&CPUTempThresholdHi);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CPU Temperature high threshold (in centigrade): %d.\n", CPUTempThresholdHi);
				else
				  printf("  Couldn't read CPU temperature high threshold, status: 0x%x.\n", status);
				
				printf("\n");
				printf("\n");
			break;
			case '8':
				printf("Set CPU Temperature Thresholds: \n");
				printf("  Low threshold: ");
                		scanf("%d", &TemperatureTemp);
				printf("  High threshold: ");
                		scanf("%d", &TemperatureTemp1);
				                                               
				status = CMCSetCPUTemperatureLowThreshold(TemperatureTemp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CPU Temperature low threshold (in centigrade) is set to: %d.\n", TemperatureTemp);
				else
				  printf("  Couldn't set CPU temperature low threshold, status: 0x%x.\n", status);
				status = CMCSetCPUTemperatureHiThreshold(TemperatureTemp1);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CPU Temperature high threshold (in centigrade) is set to: %d.\n", TemperatureTemp1);
				else
				  printf("  Couldn't set CPU temperature hi threshold, status: 0x%x.\n", status);
				printf("\n");
				printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessBladeControl()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

        char junk[80];
	int Temp;
	int Temp1;
		int BladeStatus;
        int BladeControlRescan;
		int i;
		int NumberOfBlade;

	    while(!done1)
	    {
		printf("\nCMC Blade Control Functions:\n");
		printf("0 = Read Blade Control Status              1 = Send Control To Blade\n");
		printf("2 = Read Blade Status                      3 = Read CMC Status \n");
		printf("4 = Reset Foreign CMC                      5 = Set Local CMC to Active\n");
		printf("6 = Set Local CMC to Standby               7 = Send the heartbeat to foreign CMC\n");
		printf("8 = Read the heartbeat of foreign CMC\n");
		printf("9 = Read Blade Configuration\n");
		printf("x = exit\n");
		printf("Input Command Character - ");
				// chl
		scanf("%s", junk);
		Cmd = tolower(junk[0]);
		printf("\n");
		printf("\n\n");
		if(Cmd == 'x')
		{
			done1 = TRUE;
		}
		else
	{
		switch(Cmd)
		{
			case '0':
				printf("Read Blade Control Status: \n");
				                                               
				printf("  Enter Blade number ( 1 - 16): ");
                		scanf("%d", &Temp);
                printf("  Enter rescan interval (in seconds, 0 means just read once): ");
                        scanf("%d", &BladeControlRescan);

                do {
                    status = CMCReadBladeControlStatus(Temp, &BladeStatus);
                    if ( status == CMC_STATUS_CMD_SUCCESS) {
                        // Bits 0-2:    reserved
                        // Bit 3:       Force 1GE if clear
                        // Bit 4:       Network isolation if clear
                        // Bit 5:       Blade powered down if clear
                        // Bit 6:       Blade shifty bus throttled if set
                        // Bit 7:       Blade reset if clear
                        // Bit 8:       IMC reset when clear
                        printf("  CMC blade-%02d control status: 0x%03X.\n", Temp, BladeStatus);
                        if (!(BladeStatus & 0x08)) {
                            printf("   !! Blade is forced to 1GE.\n");
                        }
                        if (!(BladeStatus & 0x10)) {
                            printf("   !! Blade is isolated.\n");
                        }
                        if (!(BladeStatus & 0x20)) {
                            printf("   !! Blade is powered down.\n");
                        }
                        if (BladeStatus & 0x40) {
                            printf("   !! Blade is throttled via shifty bus.\n");
                        }
                        if (!(BladeStatus & 0x80)) {
                            printf("   !! Blade is reset.\n");
                        }
                        if (!(BladeStatus & 0x100)) {
                            printf("   !! IMC is reset.\n");
                        }
                    } else {
                        printf("  Couldn't read CMC blade control status, status: 0x%x.\n", status);
                        break;
                    }
                    if (BladeControlRescan > 0) {
                        sleep(BladeControlRescan);
                    } else {
                        break;
                    }
                } while (1);

				printf("\n");
			break;
			case '1':
				printf("CMC Send Control To Blade: \n");
				                                               
				printf("  Enter Blade number ( 1 - 16): ");
                		scanf("%d", &Temp);
				printf("  Control bit map definitions:\n");
				printf("    Bit 8: IMC reset when clear\n");
				printf("    Bit 7: Blade reset when clear\n");
				printf("    Bit 6: Blade throttled when set\n");
				printf("    Bit 5: Blade power down when clear\n");
				printf("    Bit 4: Network isolation when clear\n");
				printf("    Bit 3: Force 1GE when clear\n");				
				printf("  Enter the control bit Map in Hex: ");
                		scanf("%x", &Temp1);
				status = CMCToBladeControlOn(Temp, Temp1);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC blade control 0x%x sent.\n", Temp1);
				else
				  printf("  Error sending the blade control, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '2':
				printf("Read Blade Status: \n");
				                                               
				printf("  Enter Blade number ( 1 - 16): ");
                		scanf("%d", &Temp);
				status = CMCReadBladeStatus(Temp, &BladeStatus);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC blade status: 0x%x.\n", BladeStatus);
				else
				  printf("  Couldn't read CMC blade status, status: 0x%x.\n", status);
				status = CMCReadBladeSubjectInputValueRegister(Temp, &BladeStatus);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Blade Subject Input Value Register: 0x%x.\n", BladeStatus);
				else
				  printf("  Couldn't read CMC blade input register, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '3':
				printf("Read CMC Status: \n");
				                                               
				status = CMCIsForeignCMCPresent(&Temp);
				if (status == 0)
				{
					if ( Temp == CMC_FOREIGN_CMC_PRESENT) 
				  		printf("  Foreign CMC is present.\n");
					else
				  		printf("  Foreign CMC is absent.\n");
				}
				status = CMCReadLocalCMCStatus(&Temp);
				if ( Temp  == CMC_ACTIVE) 
				  printf("  Local CMC is active.\n");
				else 
				{
				  if ( Temp  == CMC_STANDBY) 
				    printf("  Local CMC is in standby mode.\n");
				  else 
					printf("  Local CMC status is unknown.\n");
				}
				status = CMCReadForeignCMCStatus(&Temp);
				if ( Temp  == CMC_ACTIVE) 
				  printf("  Foreign CMC is active.\n");
				else if (Temp == CMC_STANDBY)
				  printf("  Foreign CMC is not active.\n");
				else
				  printf("  Foreign CMC status is unknown.\n");
				printf("\n");
			break;
			case '4':
				printf("Reset Foreign CMC: \n");
				                                               
				status = CMCResetForeignCMC();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Foreign CMC is reset.\n");
				else
				{
					if (status == CMC_STATUS_CMD_NO_SUCH_DEVICE)
				  		printf("  Foreign CMC is not present.\n");
				  	else
				  		printf("  Error resetting foreign CMC, status: 0x%x.\n", status);
				}
				printf("\n");
			break;
			case '5':
				printf("Set Local CMC To Active State: \n");
				                                               
				status = CMCSetLocalCMCActive();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Local CMC is set to the active state.\n");
				else
				  printf("  Error setting local CMC, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '6':
				printf("Set Local CMC To Standby: \n");
				                                               
				status = CMCSetLocalCMCStandby();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Local CMC is set to the standby state.\n");
				else
				  printf("  Error setting local CMC, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '7':
				printf("Send the heartbeat to foreign CMC: \n");
				                                               
				status = CMCSendHeartBeatToForeignCMC();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Heartbeat was sent to foreign CMC.\n");
				else if (status == CMC_STATUS_CMD_NO_SUCH_DEVICE)
				  printf("  Foreign CMC is not present.\n");
				else
				  printf("  Error sending heartbeat to foreign CMC, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '8':
				printf("Read the heartbeat of foreign CMC: \n");
				                                               
				status = CMCReadHeartbeatOfForeignCMC(&Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				  printf("  Heartbeat of the foreign CMC = %d.\n", Temp);
				}
				else
				  printf("  Error reading heartbeat, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '9':
				printf("Read the blade configuration: \n");

				NumberOfBlade = 0;
				
				for (i = 1; i <= CMC_MAX_BLADE_SLOTS; i++)
				{                                               
					status = CMCReadBladeStatus( i, &BladeStatus);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
					{
						// if (BladeStatus & 0x8000)
						// Blade present is blade blank
						// present when the blade is
						// not power on
						if ((BladeStatus & CMC_BLADE_BLANK_PRESENT)
						   || (BladeStatus & CMC_BLADE_PRESENT))
						{
						   printf("  Blade %d is present, Blade status: 0x%x\n", i, BladeStatus);
						   NumberOfBlade += 1;
						} 
					}
					else
					{
				  		printf("  Error reading blade status, status: 0x%x.\n", status);
					}
				}
				if (NumberOfBlade == 0)
					printf("There is no blade present in the system.\n");
				else
				{
					printf("\n");
					if (NumberOfBlade == 1)
					   printf("There is %d blade in the system\n", NumberOfBlade);
					else
					   printf("There are %d blades in the system\n", NumberOfBlade);
					
				}
				printf("\n");
			break;
		    } // While done1
		}
	}
}

int CMCBladeCallBackFunction(short BladeStatus)
{
	printf("********* Returned from blade interrupt call.\n");
	printf("CMCBladeCallBackFunction, Blade status: 0x%x\n", BladeStatus);
	return 0;
}

int CMCFanCallBackFunction(short FanStatus)
{
	printf("********* Returned from fan interrupt call.\n");
	printf("CMCFanCallBackFunction, Fan status: 0x%x\n", FanStatus);
	return 0;
}
int CMCPSUCallBackFunction( short PSUStatus)
{
	int 	status;
	int PowerSupplyStatus;
	int i, temp;
	int value_one = 1;
	int temp1, c;

	printf("********* Returned from PSU interrupt call.\n");
	printf("INT: 0x%x", PSUStatus);
	for (i = 0; i < 6; i++)
	{
		temp1 =  value_one << i;
		if (PSUStatus & temp1)
		{
			printf(", ");
			temp = i + 1;
	status = CMCReadPSUSubjectInputValueRegister(temp, &PowerSupplyStatus);
	if ( status == CMC_STATUS_CMD_SUCCESS) 
 		printf("%d: 0x%x", temp, PowerSupplyStatus);
	else
  		printf("  Couldn't read the PSU subject input register, status: 0x%x.\n", status);
		}
	}
	printf("\n");
	fflush(stdout);
	return 0;
}
int CMCIOMCallBackFunction(short IOMStatus)
{
	printf("********* Returned from IOM interrupt call.\n");
	printf("CMCIOMCallBackFunction, IOM status: 0x%x\n", IOMStatus);
	return 0;
}
int CMCECCCallBackFunction(short ECCStatus)
{
	printf("********* Returned from ECC interrupt call.\n");
	printf("CMCECCCallBackFunction, ECC status: 0x%x\n", ECCStatus);
	return 0;
}
int CMCKVMCallBackFunction( short KVMStatus)
{
	static short val=0;

        if (val != KVMStatus) {
                os_info("missed %d interrupts at %d", KVMStatus-val, val);
                printf("missed %d interrupts at %d", KVMStatus-val, val);
                val = KVMStatus;
        }
	val++;
	printf("********* Returned from KVM interrupt call.\n");
	printf("CMCKVMCallBackFunction, KVM status: 0x%x\n", KVMStatus);
	return 0;
}
int CMCCPCallBackFunction(short CPStatus)
{
	printf("********* Returned from CP interrupt call.\n");
	printf("CMCCPCallBackFunction, CP status: 0x%x\n", CPStatus);
	return 0;
}
int CMCShiftyCallBackFunction( short ShiftyStatus)
{
	printf("********* Returned from Shifty interrupt call.\n");
	printf("CMCCPCallBackFunction, Shifty status: 0x%x\n", ShiftyStatus);
	return 0;
}

void ProcessInterrupts()
{
	booln done1 = FALSE;
	int Cmd, c;
	int status;

        char junk[80];
	int temp, temp1;

    while(!done1)
    {
	printf("\nCMC Interrupt Related Functions:\n");
	printf("0 = Register Blade Interrupt                   1 = Generate Blade Interrupt\n");
	printf("2 = Register Fan Intrrupt                      3 = Generate Fan Interrupt\n");
	printf("4 = Register PSU Intrrupt                      5 = Generate PSU Interrupt\n");
	printf("6 = Register IOM Intrrupt                      7 = Generate IOM Interrupt\n");
	printf("8 = Register KVM Intrrupt                      9 = Generate KVM Interrupt\n");
	printf("a = Register CP Intrrupt                       b = Generate CP Interrupt\n");
	printf("c = Register Shifty Intrrupt                   d = Generate Shifty Interrupt\n");
	printf("e = Mask/Unmask Fan Interrupts                 f = Mask/Unmask Shifty Interrupts\n");
	printf("g = Mask/Unmask PSU Interrupts                 h = Mask/Unmask IOM Interrupts\n");
	printf("i = Mask/Umnask KVM Interrupts                 j = Mask/Unmask CP Interrupts\n");
	printf("k = Mask/Unmask Blade Interrupts\n");
	printf("l = Disable/Enable Fan Interrupts              m = Disable/Enable Shifty Interrupts\n");
	printf("n = Disable/Enable PSU Interrupts              o = Disable/Enable IOM Interrupts\n");
	printf("p = Disable/Enable KVM Interrupts              q = Disable/Enable CP Interrupts\n");
	printf("r = Disable/Enable Blade Interrupts\n");
	printf("s = Register ECC Intrrupt                      t = Generate ECC Interrupt\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("CMC Register Blade Interrupt: \n");
				                                               
				status = CMCRegisterBladeSubjectInterrupt((int *)CMCBladeCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC blade interrupt call back is registered.\n");
				else
				  printf("  Couldn't register CMC blade interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '1':
				printf("CMC Generate Blade Interrupt: \n");
				                                               
				status = generate_blade_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC blade interrupt.\n");
				else
				  printf("  Couldn't generate CMC blade interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '2':
				printf("CMC Register Fan Interrupt: \n");
				                                               
				status = CMCRegisterFanSubjectInterrupt((int *)CMCFanCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC fan interrupt call back is registered.\n");
				else
				  printf("  Couldn't register CMC fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '3':
				printf("CMC Generate Fan Interrupt: \n");
				                                               
				status = generate_fan_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC fan interrupt.\n");
				else
				  printf("  Couldn't generate CMC fan interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '4':
				printf("CMC Register PSU Interrupt: \n");
				                                               
				status = CMCRegisterPSUSubjectInterrupt((int *)CMCPSUCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC PSU interrupt call back is registered.\n");
				else
				  printf("  Couldn't register PSU fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '5':
				printf("CMC Generate PSU Interrupt: \n");
				                                               
				status = generate_psu_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC PSU interrupt.\n");
				else
				  printf("  Couldn't generate CMC fan interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '6':
				printf("CMC Register IOM Interrupt: \n");
				                                               
				status = CMCRegisterIOMSubjectInterrupt((int *)CMCIOMCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC IOM interrupt call back is registered.\n");
				else
				  printf("  Couldn't register IOM fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '7':
				printf("CMC Generate IOM Interrupt: \n");
				                                               
				status = generate_iom_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC IOM interrupt.\n");
				else
				  printf("  Couldn't generate CMC fan interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '8':
				printf("CMC Register KVM Interrupt: \n");
				                                               
				status = CMCRegisterKVMSubjectInterrupt((int *)CMCKVMCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC KVM interrupt call back is registered.\n");
				else
				  printf("  Couldn't register KVM fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case '9':
				printf("CMC Generate KVM Interrupt: \n");
				                                               
				status = generate_kvm_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC KVM interrupt.\n");
				else
				  printf("  Couldn't generate CMC KVM interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'a':
				printf("CMC Register CP Interrupt: \n");
				                                               
				status = CMCRegisterCPInterrupt((int *)CMCCPCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC CP interrupt call back is registered.\n");
				else
				  printf("  Couldn't register CP fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'b':
				printf("CMC Generate CP Interrupt: \n");
				                                               
				status = generate_cp_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC CP interrupt.\n");
				else
				  printf("  Couldn't generate CMC CP interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'c':
				printf("CMC Register Shifty Interrupt: \n");
				                                               
				status = CMCRegisterShiftyBusInterrupt((int *)CMCShiftyCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Shifty interrupt call back is registered.\n");
				else
				  printf("  Couldn't register Shifty fan interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'd':
				printf("CMC Generate Shifty Interrupt: \n");
				                                               
				status = generate_shifty_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC shifty interrupt.\n");
				else
				  printf("  Couldn't generate CMC shifty interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'e':
				printf("CMC Mask/Unmask Fan Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCFanMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC fan interrupt is masked.\n");
					else
				  		printf("  CMC fan interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC shifty interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'f':
				printf("CMC Mask/Unmask Shifty Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCShiftyBusMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC shifty interrupt is masked.\n");
					else
				  		printf("  CMC shifty interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC shifty interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'g':
				printf("CMC Mask/Unmask PSU Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCPowerSupplyMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC power supply interrupt is masked.\n");
					else
				  		printf("  CMC power supply interrupt is unmaked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC power supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'h':
				printf("CMC Mask/Unmask IOM Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCIOMMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC IOM interrupt is masked.\n");
					else
				  		printf("  CMC IOM supply interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC IOM supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'i':
				printf("CMC Mask/Unmask KVM Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCKVMMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC KVM interrupt is masked.\n");
					else
				  		printf("  CMC KVM supply interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC KVM supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'j':
				printf("CMC Mask/Unmask CP Interrupts: \n");

				printf("  Option (1: Mask, 2: Unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCCPMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC CP interrupt is masked.\n");
					else
				  		printf("  CMC CP interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC CP interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'k':
				printf("CMC Mask/Unmask blade Interrupts: \n");

				printf("  Option (1: mask, 2: unmask ): ");
                		scanf("%d", &temp);
				printf("  Enter the bit map in Hex: ");
                		scanf("%x", &temp1);
					
				status = CMCBladeMaskUnmaskInterrupt(temp1, temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC blade interrupt is masked.\n");
					else
				  		printf("  CMC blade interrupt is unmasked.\n");
				}
				else
				  printf("  Couldn't mask/unmask CMC blade supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'l':
				printf("CMC Enable/Disable Fan Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCFanDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC fan interrupt is enabled.\n");
					else
				  		printf("  CMC fan interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't generate CMC shifty interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'm':
				printf("CMC Enable/Disable Shifty Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCShiftyBusDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC shifty interrupt is enabled.\n");
					else
				  		printf("  CMC shifty interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC shifty interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'n':
				printf("CMC Enable/Disable PSU Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCPowerSupplyDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC power supply interrupt is enabled.\n");
					else
				  		printf("  CMC power supply interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC power supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'o':
				printf("CMC Enable/Disable IOM Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCIOMDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC IOM interrupt is enabled.\n");
					else
				  		printf("  CMC IOM supply interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC IOM supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'p':
				printf("CMC Enable/Disable KVM Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCKVMDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC KVM interrupt is enabled.\n");
					else
				  		printf("  CMC KVM supply interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC KVM supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'q':
				printf("CMC Enable/Disable CP Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCCPDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC CP interrupt is enabled.\n");
					else
				  		printf("  CMC CP interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC CP supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 'r':
				printf("CMC Enable/Disable blade Interrupts: \n");

				printf("  Option (1: disable, 2: enable ): ");
                		scanf("%d", &temp);
					
				status = CMCBladeDisableEnableInterrupt(temp);

				                                               
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
				 	if (temp == 2)
				  		printf("  CMC blade interrupt is enabled.\n");
					else
				  		printf("  CMC blade interrupt is disabled.\n");
				}
				else
				  printf("  Couldn't enable/disable CMC blade supply interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 's':
				printf("CMC Register ECC Interrupt: \n");
				                                               
				status = CMCRegisterECCSubjectInterrupt((int *)CMCECCCallBackFunction);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC ECC interrupt call back is registered.\n");
				else
				  printf("  Couldn't register IOM interrupt call back, status: %x.\n", status);
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
			case 't':
				printf("CMC Generate ECC Interrupt: \n");
				                                               
				status = generate_ecc_interrupt_simulate();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  Generated CMC ECC interrupt.\n");
				else
				  printf("  Couldn't generate CMC ECC interrupt.\n");
                        	// chl, clean the stdin buffer
                        	c = fgetc (stdin);
                        	// chl, clean the stdin buffer
                        	while(c != '\n')
                                	c = fgetc (stdin);

                        	printf("\nPress ENTER to continue...\n");
                        	getchar();
				printf("\n");
			break;
		    } // While done1
		}
	}
}
void ProcessMiscFunctions()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

        char junk[80];
	int Temp;

    while(!done1)
    {
	printf("\nCMC Misc Information:\n");
	printf("0 = Read Slot ID                               1 = Read Stream Revision\n");
	printf("2 = Read Board Revision                        3 = Read Mid-plane Revision\n");
	printf("4 = Read Battery Status                        5 = Read System Power Status\n");
	printf("6 = Read Password Mode                         7 = Read Manufacture Mode\n");
	printf("8 = Read PSU1 SMBUS Timeout Statistics         9 = Read PSU2 SMBUS Timeout Statistics\n");
	printf("a = Read IOM1 SMBUS Timeout Statistics         b = Read IOM2 SMBUS Timeout Statistics\n");
	printf("c = Read KVM SMBUS Timeout Statistics\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("Read Slot ID: \n");
				                                               
				status = CMCReadSlotID(&Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC slot id: 0x%x.\n", Temp);
				else
				  printf("  Couldn't read CMC slot id, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '1':
				printf("Read Stream Revision: \n");
				                                               
				status = CMCReadStreamRevision(&Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC stream revision: 0x%x.\n", Temp);
				else
				  printf("  Error reading the stream revision, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '3':
				printf("Read Mid-plane Revision: \n");
				                                               
				status = CMCReadMidPlaneRevision(&Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Midplane revision: 0x%x.\n", Temp);
				else
				  printf("  Error reading the Midplane revision, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '2':
				printf("Read Board Revision: \n");
				                                               
				status = CMCReadBoardRevision(&Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC Board revision: %d.\n", Temp);
				else
				  printf("  Error reading the board revision, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '4':
				printf("Read Battery Status: \n");
				                                               
				status = CMCIsBatteryPowerGood();
				if ( status == 1) 
				  printf("  CMC Battery is good, status: 0x%x.\n", status);
				else
				  printf("  CMC Battery is bad, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '5':
				printf("Read System Power Status: \n");
				                                               
				status = CMCIsSystemPowerGood();
				if ( status == 1) 
				  printf("  CMC system power is good, status: 0x%x.\n", status);
				else
				  printf("  CMC system power is bad, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '6':
				printf("Read Password Mode: \n");
				                                               
				status = CMCReadPasswordMode(&Temp);
				if ( status == 0) 
				{
					if (Temp == CMC_GPIO_PASSWORD_MODE)
						printf(" CMC is in password mode.\n");
					else
						printf(" CMC is NOT in password mode.\n");
				}
				else
				  printf("  Can't read the CMC password mode, status: status: 0x%x.\n", status);
				printf("\n");
			break;
			case '7':
				printf("Read Manufacture Mode: \n");
				                                               
				status = CMCReadMFGMode(&Temp);
				if ( status == 0) 
				{
					if (Temp == CMC_GPIO_MANUFACTURE_MODE)
						printf(" CMC is in Munufacture mode.\n");
					else
						printf(" CMC is NOT in Manufacture mode.\n");
				}
				else
				  printf("  Can't read the CMC password mode, status: status: 0x%x.\n", status);
				printf("\n");
			break;
			case '8':
				printf("Read PSU1 SMBUS Timeout Statistics: \n");
				                                               
				status = CMCReadSMBUSTimeoutStat(2, &Temp);
				if ( status == 0) 
				{
					printf("Number of SMBUS timeout for PSU1: %d\n", Temp);
				}
				else
				  printf("  Can't read the SMBUS timeout statistics, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '9':
				printf("Read PSU2 SMBUS Timeout Statistics: \n");
				                                               
				status = CMCReadSMBUSTimeoutStat(3, &Temp);
				if ( status == 0) 
				{
					printf("Number of SMBUS timeout for PSU2: %d\n", Temp);
				}
				else
				  printf("  Can't read the SMBUS timeout statistics, status: 0x%x.\n", status);
				printf("\n");
			break;
			case 'a':
				printf("Read IOM1 SMBUS Timeout Statistics: \n");
				                                               
				status = CMCReadSMBUSTimeoutStat(0, &Temp);
				if ( status == 0) 
				{
					printf("Number of SMBUS timeout for IOM1: %d\n", Temp);
				}
				else
				  printf("  Can't read the SMBUS timeout statistics, status: 0x%x.\n", status);
				printf("\n");
			break;
			case 'b':
				printf("Read IOM2 SMBUS Timeout Statistics: \n");
				                                               
				status = CMCReadSMBUSTimeoutStat(1, &Temp);
				if ( status == 0) 
				{
					printf("Number of SMBUS timeout for IOM2: %d\n", Temp);
				}
				else
				  printf("  Can't read the SMBUS timeout statistics, status: 0x%x.\n", status);
				printf("\n");
			break;
			case 'c':
				printf("Read KVM SMBUS Timeout Statistics: \n");
				                                               
				status = CMCReadSMBUSTimeoutStat(4, &Temp);
				if ( status == 0) 
				{
					printf("Number of SMBUS timeout for KVM: %d\n", Temp);
				}
				else
				  printf("  Can't read the SMBUS timeout statistics, status: 0x%x.\n", status);
				printf("\n");
			break;
		    } // While done1
		}
	}
}

void ProcessKVMFunctions()
{
	booln done1 = FALSE;
	int Cmd;
	int status;

        char junk[80];
	int Temp;

    while(!done1)
    {
	printf("\nCMC KVM Functions:\n");
	printf("0 = Read KVM Configuration                     1 = Reset KVM\n");
	printf("2 = Power On/Off KVM\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
             		// chl
        scanf("%s", junk);
        Cmd = tolower(junk[0]);
        printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("CMC KVM Configuration: \n");
				                                               
				status = CMCKVMIsPresent(&Temp);
				if (status == 0)
				{
					if ( Temp == CMC_KVM_PRESENT) 
				  		printf("  KVM is present.\n");
					else
				  		printf("  KVM is absent.\n");
				}
				else
					printf("Can't read KVM present status: 0x%x\n", status);
				status = CMCKVMBlankIsPresent(&Temp);
				if (status == 0)
				{
					if ( Temp == CMC_KVM_BLANK_PRESENT) 
				  		printf("  KVM blank is present.\n");
					else
				  		printf("  KVM blank is absent.\n");
				}
				else
					printf("Can't read KVM blank present status: 0x%x\n", status);
				status = CMCReadKVMPowerStatus(&Temp);
				if (status == 0)
				{
					if (Temp == CMC_KVM_POWER_ON)
			  			printf("  KVM is powered on.\n");
					else if (Temp == CMC_KVM_POWER_OFF)
			  			printf("  KVM is powered off.\n");
					else if (Temp == CMC_KVM_POWER_ON_UNKNOWN)
			  			printf("  KVM powered status is unknown.\n");
				}
				printf("\n");
			break;
			case '1':
				printf("Reset KVM: \n");
				                                               
				status = CMCResetKVM();
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				  printf("  CMC KVM is reset.\n");
				else
				  printf("  Error resetting KVM, status: 0x%x.\n", status);
				printf("\n");
			break;
			case '2':
				printf("Power On/Off KVM: \n");
				printf("  Option (1: on, 0: off ): ");
                		scanf("%d", &Temp);
				status = CMCPowerOnOffKVM(Temp);
				if ( status == CMC_STATUS_CMD_SUCCESS) 
				{
					if (Temp == CMC_KVM_POWER_ON)
			  			printf("  KVM is turned on\n");
					else
			  			printf("  KVM is turned off\n");
				}
				else
			  		printf("  Couldn't turn on/off the KVM, status: 0x%x.\n", status);
				printf("\n");
			break;
		    } // While done1
		}
	}
}
void IOM1StressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	char junk[80];
	int Temp;
	int iteration;
	int pattern;

    while(!done1)
    {
	printf("\nCMC IOM Stress Testing:\n");
	printf("0 = IOM1 Read Stress Testing\n");
	printf("1 = IOM1 Write Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("IOM Read Stress Testing.\n");
					printf("Read Xilinx I2C IOM 1 register:\n");
					printf("  Enter I2C base address(default: 0xE4): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCReadXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else 
						status = CMCReadXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{

					   		//DumpBuffer(i2c_data, i2c_length);
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCReadXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else 
						status = CMCReadXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{
			//		   		DumpBuffer(i2c_data, i2c_length);					
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				}
					printf("\n");
			break;
			case '1':
					printf("IOM Write Stress Testing.\n");
					printf("Write Xilinx I2C IOM 1 register:\n");
					printf("  Enter I2C base address(default: 0xE4): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					memset(i2c_data, pattern, i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
						if (status != 0)
						{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
						}
						else
						{
							if ((base >= 0xa0) & (base <= 0xaf))
								status = CMCReadXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data1);
							else 
								status = CMCReadXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data1);
							if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
							{
				   	  		   printf("I2c write verification failed\n");
							   break;
							}
						} // end of if (status != 0)
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data);
					if (status != 0)
					{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
					}
					else
					{
						if ((base >= 0xa0) & (base <= 0xaf))
							status = CMCReadXilinxI2CIOM1DataWord(base, offset, i2c_length, i2c_data1);
						else 
							status = CMCReadXilinxI2CIOM1DataOneTime(base, offset, i2c_length, i2c_data1);
						if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
						{
				     		   printf("I2c write verification failed\n");
						   break;
						}
					} // end of if (status != 0)
					}
				}
					printf("\n");
			break;
			case '2':
			break;
		    } // While done1
		}
	}
}
void IOM2StressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	char junk[80];
	int Temp;
	int iteration;
	int pattern;

    while(!done1)
    {
	printf("\nCMC IOM 2 Stress Testing:\n");
	printf("0 = IOM 2 Read Stress Testing\n");
	printf("1 = IOM 2 Write Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("IOM 2 Read Stress Testing.\n");
					printf("Read Xilinx I2C IOM 2 register:\n");
					printf("  Enter I2C base address(default: 0xE4): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						if ((base >= 0xa0) & (base <= 0xaf))
							status = CMCReadXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
						else 
							status = CMCReadXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{

					   		//DumpBuffer(i2c_data, i2c_length);
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						if ((base >= 0xa0) & (base <= 0xaf))
							status = CMCReadXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
						else 
							status = CMCReadXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{
			//		   		DumpBuffer(i2c_data, i2c_length);					
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				}
					printf("\n");
			break;
			case '1':
					printf("IOM 2 Write Stress Testing.\n");
					printf("Write Xilinx I2C IOM 2 register:\n");
					printf("  Enter I2C base address(default: 0xE4): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					memset(i2c_data, pattern, i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
						if (status != 0)
						{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
						}
						else
						{
							if ((base >= 0xa0) & (base <= 0xaf))
								status = CMCReadXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data1);
							else 
								status = CMCReadXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data1);
							if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
							{
				   	  		   printf("I2c write verification failed\n");
							   break;
							}
						} // end of if (status != 0)
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					if ((base >= 0xa0) & (base <= 0xaf))
						status = CMCWriteXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data);
					else
						status = CMCWriteXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data);
					if (status != 0)
					{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
					}
					else
					{
						if ((base >= 0xa0) & (base <= 0xaf))
							status = CMCReadXilinxI2CIOM2DataWord(base, offset, i2c_length, i2c_data1);
						else 
							status = CMCReadXilinxI2CIOM2DataOneTime(base, offset, i2c_length, i2c_data1);
						if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
						{
				   	  	   printf("I2c write verification failed\n");
						   break;
							}
					} // end of if (status != 0)
					}
				}
					printf("\n");
			break;
			case '2':
			break;
		    } // While done1
		}
	}
}

void KVMStressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	char junk[80];
	int Temp;
	int iteration;
	int pattern;

    while(!done1)
    {
	printf("\nCMC KVM Stress Testing:\n");
	printf("0 = KVM Read Stress Testing\n");
	printf("1 = KVM Write Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("KVM Read Stress Testing.\n");
					printf("Read Xilinx I2C KVM register:\n");
					printf("  Enter I2C base address(default: 0xA0): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CKVMData(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{

					   		//DumpBuffer(i2c_data, i2c_length);
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CKVMData(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{
			//		   		DumpBuffer(i2c_data, i2c_length);					
						}
						else
						{
					   		printf("I2c error occrred when reading IOM data, status: 0x%x\n", status);
							break;
						}
					}
				}
					printf("\n");
			break;
			case '1':
					printf("KVM Write Stress Testing.\n");
					printf("Write Xilinx I2C KVM register:\n");
					printf("  Enter I2C base address(default: 0xA0): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					memset(i2c_data, pattern, i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCWriteXilinxI2CKVMData(base, offset, i2c_length, i2c_data);
						if (status != 0)
						{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
						} 
						else
						{
							// Read back to verify
							status = CMCReadXilinxI2CKVMData(base, offset, i2c_length, i2c_data1);
							if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
							{
				   	  		   printf("I2c write verification failed\n");
							   break;
							}
						} // end of if (status != 0)
					} // end of for temp
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)						{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					status = CMCWriteXilinxI2CKVMData(base, offset, i2c_length, i2c_data);
					if (status != 0)
					{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
					}
					} // end of for Temp
				} // end of for iteration
					printf("\n");
			break;
			case '2':
			break;
		    } // While done1
		}
	}
}
void PSU1StressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	char junk[80];
	int Temp;
	int iteration;
	int pattern;

    while(!done1)
    {
	printf("\nCMC PSU1 Stress Testing:\n");
	printf("0 = PSU1 Read Stress Testing\n");
	printf("1 = PSU1 Write Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("PSU 1 Stress Testing.\n");
					printf("Read Xilinx I2C PSU 1 register:\n");
					printf("  Enter I2C base address(default: 0xA0): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
					if (iteration == -1)
						printf("  Will run forever.\n");
					else
						printf("  Will run %d times.\n",
						iteration);
				if (iteration != -1)
				{
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{

					   		//DumpBuffer(i2c_data, i2c_length);
						}
						else
						{
					   		printf("I2c error occrred when reading KVM data, status: 0x%x\n", status);
							break;
						}
					}
				} else
				  {
				
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{
			//		   		DumpBuffer(i2c_data, i2c_length);					
						}
						else
						{
					   		printf("I2c error occrred when reading KVM data, status: 0x%x\n", status);
							break;
						}
					}
				}
					printf("\n");
			break;
			case '1':
					printf("PSU1 Write Stress Testing.\n");
					printf("Write Xilinx I2C PSU1 register:\n");
					printf("  Enter I2C base address(default: 0xA0): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					memset(i2c_data, pattern, i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCWriteXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
						if (status != 0)
						{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
						} 
						else
						{
							// Read back to verify
							status = CMCReadXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data1);
							if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
							{
				   	  		   printf("I2c write verification failed\n");
							   break;
							}
						} // end of if (status != 0)
					} // end of for temp
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)						{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					status = CMCWriteXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data);
					if (status != 0)
					{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
					}
					else
					{
						// Read back to verify
						status = CMCReadXilinxI2CPSU1Data(base, offset, i2c_length, i2c_data1);
						if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
						{
				     		   printf("I2c write verification failed\n");
						   break;
						}
					} // end of if (status != 0)
					} // end of for Temp
				} // end of for iteration
					printf("\n");
			break;
			case '2':
			break;
		    } // While done1
		}
	}
}
void ReadCPFRU()
{
	int status;
	int base, offset;
	int i2c_length;

	printf("Read CP FRU.\n");
	printf("  Enter I2C offset in hex: ");
        scanf("%x", &offset);
	printf("  I2C offset: 0x%x entered\n",
		offset);
	printf("  Enter length in decimal: ");
        scanf("%d", &i2c_length);
	printf("  length: %d entered\n",
		i2c_length);
	status = CMCReadCPFRU(offset, i2c_length, i2c_data);
	if (status == 0)
	{

   		DumpBuffer(i2c_data, i2c_length);
	}
	else
	{
  		printf("I2c error occrred when reading CP FRU, status: 0x%x\n", status);
	}
}
void ReadCMCFRU()
{
	int status;
	int offset;
	int i2c_length;

		printf("Read CMC FRU.\n");
		printf("  Enter I2C offset in hex: ");
               	// chl
               	scanf("%x", &offset);
		printf("  I2C offset: 0x%x entered\n",
			offset);
		printf("  Enter length in decimal: ");
               	// chl
               	scanf("%d", &i2c_length);
		printf("  length: %d entered\n",
			i2c_length);
		status = CMCReadCMCFRU(offset, i2c_length, i2c_data);
		if (status == 0)
		{

	   		DumpBuffer(i2c_data, i2c_length);
		}
		else
		{
	  		printf("I2c error occrred when reading CMC FRU, status: 0x%x\n", status);
		}
}
void PSU2StressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset;
	int i2c_length;
	char junk[80];
	int Temp;
	int iteration;
	int pattern;

    while(!done1)
    {
	printf("\nCMC PSU2 Stress Testing:\n");
	printf("0 = PSU2 Read Stress Testing\n");
	printf("1 = PSU2 Write Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
					printf("PSU 2 Stress Testing.\n");
					printf("Read Xilinx I2C PSU 2 register:\n");
					printf("  Enter I2C base address(default: 0xA0): ");
                			// chl
                			scanf("%x", &base);
					printf("  I2C Base address: 0x%x entered\n",
						base);
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
					if (iteration == -1)
						printf("  Will run forever.\n");
					else
						printf("  Will run %d times.\n",
						iteration);
				if (iteration != -1)
				{
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{

					   		//DumpBuffer(i2c_data, i2c_length);
						}
						else
						{
					   		printf("I2c error occrred when reading KVM data, status: 0x%x\n", status);
							break;
						}
					}
				} else
				  {
				
					for (Temp = 0; ; Temp++)							{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCReadXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data);
						if (status == 0)
						{
			//		   		DumpBuffer(i2c_data, i2c_length);					
						}
						else
						{
					   		printf("I2c error occrred when reading KVM data, status: 0x%x\n", status);
							break;
						}
					}
				}
					printf("\n");
			break;
			case '1':
					printf("PSU 2 Stress Testing.\n");
					printf("Write Xilinx I2C PSU 2 register:\n");
					printf("  Enter I2C offset in hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  I2C offset: 0x%x entered\n",
						offset);
					printf("  Enter write pattern in hex: ");
                			// chl
                			scanf("%x", &pattern);
					printf("  I2C pattern: 0x%x entered\n",
						pattern);
					printf("  Enter length in decimal: ");
                			// chl
                			scanf("%d", &i2c_length);
					printf("  length: %d entered\n",
						i2c_length);
					memset(i2c_data, pattern, i2c_length);
					printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
						status = CMCWriteXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data);
						if (status != 0)
						{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
						} 
						else
						{
							// Read back to verify
							status = CMCReadXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data1);
							if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
							{
				   	  		   printf("I2c write verification failed\n");
							   break;
							}
						} // end of if (status != 0)
					} // end of for temp
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)						{ 
						if ((Temp % 100) == 0)
						   printf("Iteration %d:\n", Temp);
					status = CMCWriteXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data);
					if (status != 0)
					{
				   	  		printf("I2c write error, status: 0x%x\n", status);
						break;
					}
					else
					{
						// Read back to verify
						status = CMCReadXilinxI2CPSU2Data(base, offset, i2c_length, i2c_data1);
						if (strncmp(i2c_data1, i2c_data, i2c_length) != 0) 
						{
				     		   printf("I2c write verification failed\n");
						   break;
						}
					} // end of if (status != 0)
					} // end of for Temp
				} // end of for iteration
					printf("\n");
			break;
			case '2':
			break;
		    } // While done1
		}
	}
}

void GPIOStressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	int base, offset, result;
	char junk[80];
	int Temp;
	int iteration;
	int current_value, new_value;

    while(!done1)
    {
				printf("GPIO Stress Testing:\n");
				printf("0 = GPIO Read Stress Testing           1 = GPIO Write Stress Testing\n");
				printf("Input Command Character - ");
				scanf("%s", junk);
				Cmd = tolower(junk[0]);
				printf("\n");
				printf("\n\n");
				if (Cmd == '0')
				{
					// Read
					printf("Read GPIO register:\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					printf("  Number of times to run (-1 == forever): ");
                			scanf("%d", &iteration);
					if (iteration == -1)
						printf("  Will run forever.\n");
					else
						printf("  Will run %d times.\n",
						iteration);
					if (iteration != -1)
					{
						for (Temp = 0; Temp < iteration; Temp++)					{ 
							if ((Temp % 100) == 0)
					  		printf("Iteration %d:\n", Temp);
							status = CMCReadGpioData(base, offset, &result);
							if (status == 0)
							{
							}
							else
							{
					   			printf("GPIO error occrred, status: 0x%x\n", status);
								break;
							}
						} // end of for (Temp = 0; Temp < iteration
					} // end of if (iteration != -1)
					else
				  	{
				
						for (Temp = 0; ; Temp++)							{ 
							if ((Temp % 100) == 0)
						   	printf("Iteration %d:\n", Temp);
							status = CMCReadGpioData(base, offset, &result);
							if (status == 0)
							{
							}
							else
							{
					   			printf("GPIO error occrred, status: 0x%x\n", status);
							  	break;
							}
						} // end of for (Temp = 0; ; Temp++)
					} // end of iteration != -1
				} // end of if Cmd == '0'
				else if (Cmd == '1')
				{
					// Write
					printf("Write GPIO register:\n");
					printf("  Enter GPIO base physical address in Hex(default: 0xA0000000): ");
                			// chl
                			scanf("%x", &base);
					printf("  Base address: 0x%x entered\n",
						base);
					printf("  Enter GPIO offset in Hex: ");
                			// chl
                			scanf("%x", &offset);
					printf("  offset: 0x%x entered\n",
						offset);
					status = CMCReadGpioData(base, offset, &result);
					if (status == 0)
					{
						printf("IOCTL_GPIO_READ_CMD ioctl succeeded.\n");
						printf("current value is 0x%x\n", result);
						current_value = result;
						printf("  Enter new value in Hex: ");
                				scanf("%x", &new_value);
						printf("  New value 0x%x entered\n",
							new_value);
					} // end of if (status == 0)
					else
					{
						printf("READ GPIO ioctl failed.\n");
						break;
					}
					printf("  Number of times to run (-1 == forever): ");
                			scanf("%d", &iteration);
					if (iteration == -1)
						printf("  Will run forever.\n");
					else
						printf("  Will run %d times.\n",
							iteration);
					if (iteration != -1)
					{
						for (Temp = 0; Temp < iteration;
							 Temp++) 
						{ 
							if ((Temp % 100) == 0)
						   		printf("Iteration %d:\n", Temp);
							os_private_sem_get(CMC_HAPI_TEST_KEY, &privateSem);
							status = CMCWriteGpioData( base, offset, new_value); 
							if (status == 0)
							{
								// Read back the value to verify
								status = CMCReadGpioData(base, offset, &result);
								if (status == 0)
								{
									if (result != new_value) 
									   {
									     printf("Write verification failed, current value: 0x%x, value written: 0x%x.\n", result, new_value); 
									     os_private_sem_put(privateSem);
									     break;
								           }
									} else
									{
									     printf("Read back failed for write verification, status: 0x%x.\n", status); 
									     os_private_sem_put(privateSem);
									     break;
									}
									os_private_sem_put(privateSem);
								}
								else
								{
									printf("WRITE GPIO failed.\n");
									os_private_sem_put(privateSem);
									break;
								}
							} // end of Temp = 0; Temp < iteration; Temp++
						} // end of iteration != -1
						else
				  		{
				
							for (Temp = 0; ; Temp++)
							{ 
								if ((Temp % 100) == 0)
						   		printf("Iteration %d:\n", Temp);
								os_private_sem_get(CMC_HAPI_TEST_KEY, &privateSem);
								status = CMCWriteGpioData( base, offset, new_value); 
								if (status == 0)
								{
									// Read back the value to verify
									status = CMCReadGpioData(base, offset, &result);
									if (status == 0)
									{
									 if (result != new_value) 
				        				 {
					     					printf("Write verification failed, new_value: 0x%x, old_value: 0x%x.\n", new_value, result); 
					     					os_private_sem_put(privateSem);
					     					break;
				        			        } // end of result != new value
					} else // end of read back status == 0
					{
					     printf("Read back failed for write verification, status: 0x%x.\n", status); 
					     os_private_sem_put(privateSem);
					     break;
					}
									os_private_sem_put(privateSem);
								} // end of if writestatus == 0)
								else
								{
									printf("WRITE GPIO failed.\n");
									os_private_sem_put(privateSem);
									break;
								} // end of write status != 0
								os_private_sem_put(privateSem);
							} // end of for temp
						} // end of iteration == -1
				// end of cmd == '1', write testing
				} else
					break;
				printf("\n");
    }
}
void RepeatedStartIOStressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];
	int Temp;
	int iteration;
	int base;
	struct i2c_rdwr_ioctl_data msgset;
	struct i2c_msg *i2c_msg_ptr;
	char buf1[4];
	char buf2[4];

    while(!done1)
    {
	printf("\nCMC I2C Repeated Start I/O Stress Testing:\n");
	printf("1 = IOM1 Repeated I/O Stress Testing\n");
	printf("2 = IOM2 Repeated I/O Stress Testing\n");
	printf("3 = PSU1 Repeated I/O Stress Testing\n");
	printf("4 = PSU2 Repeated I/O Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '1':
				printf("IOM1 I2C Repeated Start I/O Stress Testing.\n");
				printf("  Enter I2C address Hex: ");
                		scanf("%x", &base);
				printf("  I2C address: 0x%x entered\n",
						base);

				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0;
						buf1[1] = 0;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 2;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_IOM1_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0;
						buf1[1] = 0;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 2;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_IOM1_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				}
					printf("\n");
			break;
			case '2':
				printf("IOM2 I2C Repeated Start I/O Stress Testing.\n");
				printf("  Enter I2C address Hex: ");
                		scanf("%x", &base);
				printf("  I2C address: 0x%x entered\n",
						base);

				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0;
						buf1[1] = 0;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 2;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_IOM2_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0;
						buf1[1] = 0;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 2;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_IOM2_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				}
					printf("\n");
			break;
			case '3':
				printf("PSU1 I2C Repeated Start I/O Stress Testing.\n");
				printf("  Enter I2C address Hex: ");
                		scanf("%x", &base);
				printf("  I2C address: 0x%x entered\n",
						base);

				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0x98;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 1;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_PSU1_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0x98;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 1;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_PSU1_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				}
					printf("\n");
			break;
			case '4':
				printf("PSU2 I2C Repeated Start I/O Stress Testing.\n");
				printf("  Enter I2C address Hex: ");
                		scanf("%x", &base);
				printf("  I2C address: 0x%x entered\n",
						base);

				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0x98;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 1;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_PSU2_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						i2c_msg_ptr = malloc(2 * sizeof(struct i2c_msg));
						// I2c offset
						memset(buf1, 0x00, 1);
						buf1[0] = 0x98;
						i2c_msg_ptr[0].addr = base >> 1;
						i2c_msg_ptr[0].flags = 0;
						i2c_msg_ptr[0].len = 1;
						i2c_msg_ptr[0].buf = buf1;
				
						// I2c Read	
						memset(buf2, 0xee, 4);
						i2c_msg_ptr[1].addr = base >> 1;
						i2c_msg_ptr[1].flags = I2C_M_RD;
						i2c_msg_ptr[1].len = 4;
						i2c_msg_ptr[1].buf = buf2;
						msgset.msgs = i2c_msg_ptr;
						msgset.nmsgs = 2;
						status = send_xilinx_i2c_general_data_repeated (DEVICE_XILINX_PSU2_I2C, &msgset);
						if (status != 0)
			   	  			printf("I2c write error, status: 0x%x\n", status);
						else
				  			DumpBuffer((unsigned char *)buf2, 4);
						free(i2c_msg_ptr);
						printf("\n");
					}
				}
					printf("\n");
			break;
		    } // While done1
		}
	}
}
void InterruptStressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	int status;
	char junk[80];
	int Temp;
	int iteration;
	int NumberOfRegisteringForKVM = 0;
	int NumberOfRegisteringForIOM = 0;
	int NumberOfRegisteringForPSU = 0;
	int NumberOfRegisteringForBlade = 0;
	int NumberOfRegisteringForCP = 0;
	int NumberOfRegisteringForFan = 0;
	int PS_bit_map;

    while(!done1)
    {
	printf("\nCMC Interrupt Stress Testing:\n");
	printf("0 = KVM Interrupt Stress Testing\n");
	printf("1 = IOM Interrupt Stress Testing\n");
	printf("2 = PSU Interrupt Stress Testing\n");
	printf("3 = Blade Interrupt Stress Testing\n");
	printf("4 = CP Interrupt Stress Testing\n");
	printf("5 = Fan Interrupt Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				printf("KVM Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForKVM == 0)
				{
					status = CMCRegisterKVMSubjectInterrupt( (int *)CMCKVMCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC KVM interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register KVM fan interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForKVM += 1;
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						status = generate_kvm_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("  Generated CMC KVM interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC KVM interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++) {
						printf("Iteration %d:\n", Temp);
						status = generate_kvm_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC KVM interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC KVM interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
			case '1':
				printf("IOM Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForIOM == 0)
				{
					status = CMCRegisterIOMSubjectInterrupt( (int *)CMCIOMCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC IOM interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register IOM interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForIOM += 1;
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						status = generate_iom_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC IOM interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC IOM interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						status = generate_iom_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC IOM interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC IOM interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
			case '2':
				printf("PSU Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForPSU == 0)
				{
					status = CMCRegisterPSUSubjectInterrupt( (int *)CMCPSUCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC PSU interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register PSU interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForPSU += 1;
#if 0
				printf("  Enter PS bit map in Hex (0x3f): ");
                		scanf("%x", &PS_bit_map);
#endif
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
#if 0
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_ON);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned on\n", PS_bit_map);
					else
				  		printf("  Couldn't turn on the power supply, status: 0x%x.\n", status);
					sleep (1);
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_OFF);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned off\n", PS_bit_map);
					else
				  		printf("  Couldn't turn off the power supply, status: 0x%x.\n", status);
#endif
						status = generate_psu_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC PSU interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC PSU interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
#if 0
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_ON);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned on\n", PS_bit_map);
					else
				  		printf("  Couldn't turn on the power supply, status: 0x%x.\n", status);
					sleep (1);
					status = CMCTurnPSOnOff(PS_bit_map, CMC_TURN_PS_OFF);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  Power supplies (bit map): 0x%x. have been turned off\n", PS_bit_map);
					else
				  		printf("  Couldn't turn off the power supply, status: 0x%x.\n", status);
#endif
						status = generate_psu_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC PSU interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC PSU interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
			case '3':
				printf("Blade Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForBlade == 0)
				{
					status = CMCRegisterBladeSubjectInterrupt( (int *)CMCBladeCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC blade interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register blade interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForBlade += 1;
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						status = generate_blade_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC blade interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC blade interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						status = generate_blade_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC blade interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC blade interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
			case '4':
				printf("CP Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForCP == 0)
				{
					status = CMCRegisterCPInterrupt( (int *)CMCCPCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC CP interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register CP interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForCP += 1;
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						status = generate_cp_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC CP interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC CP interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						status = generate_cp_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC CP interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC CP interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
			case '5':
				printf("Fan Interrupt Stress Testing.\n");
				printf("\n");

				printf("  Attention: This is the simulated interrupt.\n");
				printf("             The status returned might not contain any status.\n");
				printf("\n");
				printf("  Number of times to run (-1 == forever): ");
                			// chl
                			scanf("%d", &iteration);
				// Only register once
				if (NumberOfRegisteringForFan == 0)
				{
					status = CMCRegisterFanSubjectInterrupt( (int *)CMCFanCallBackFunction);
					if ( status == CMC_STATUS_CMD_SUCCESS) 
				  		printf("  CMC Fan interrupt call back is registered.\n");
					else
				  		printf("  Couldn't register Fan interrupt call back, status: %x.\n", status);
				}
				NumberOfRegisteringForFan += 1;
				if (iteration != -1)
				{
					printf("  Will run %d times.\n",
						iteration);
					for (Temp = 0; Temp < iteration; Temp++)					{ 
						printf("Iteration %d:\n", Temp);
						status = generate_fan_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC Fan interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC Fan interrupt.\n");
							break;
						}
						sleep (1);
					}
				} else
				{
					printf("  Will run forever.\n");
					for (Temp = 0; ; Temp++)							{ 
						printf("Iteration %d:\n", Temp);
						status = generate_fan_interrupt_simulate();
						if ( status == CMC_STATUS_CMD_SUCCESS) 
				  			printf("Generated CMC fan interrupt.\n");
						else
						{
				  			printf("  Couldn't generate CMC fan interrupt.\n");
							break;
						}
						sleep (1);
					}
				}
					printf("\n");
			break;
		    } // While done1
		}
	}
}


void ProcessCMCFRU()
{
	booln done1 = FALSE;
	int Cmd;
	char junk[80];

    while(!done1)
    {
	printf("\nCMC FRU Operations:\n");
	printf("0 = Read CMC FRU           1 = Read CP FRU\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				 	ReadCMCFRU();
			break;
			case '1':
				 	ReadCPFRU();
			break;
			} // end of switch
			printf("\n");
		} // end of cmd != x
	} // end of while done1
}
void ProcessStressTesting()
{
	booln done1 = FALSE;
	int Cmd;
	char junk[80];

    while(!done1)
    {
	printf("\nCMC Stress testing:\n");
	printf("0 = IOM 1 Stress Testing           1 = IOM 2 Stress Testing\n");
	printf("2 = KVM Stress Testing             3 = PSU 1 Stress Testing\n");
	printf("4 = PSU 2 Stress Testing\n");
	printf("5 = GPIO Stress Testing\n");
	printf("6 = Interrupt Stress Testing\n");
	printf("7 = I2C repeated start I/O Stress Testing\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
				 	IOM1StressTesting();
			break;
			case '1':
				 	IOM2StressTesting();
			break;
			case '2':
					KVMStressTesting();
			break;
			case '3':
					PSU1StressTesting();
			break;
			case '4':
					PSU2StressTesting();
			break;
			case '5':
					GPIOStressTesting();
			break;
			case '6':
					InterruptStressTesting();
			break;
			case '7':
					RepeatedStartIOStressTesting();
			break;
			} // end of switch
			printf("\n");
		} // end of cmd != x
	} // end of while done1
}

int IOM1BusScan()
{
	int device_address;
	int status;

	for (device_address = 0; device_address <= 0xfe; device_address += 2)
	{
		printf("Scanning IOM 1 device : 0x%x\n", device_address);
		if ((device_address >= 0xa0) & (device_address <= 0xaf))
			status = CMCReadXilinxI2CIOM1DataWord(device_address, 0, 2, i2c_data);
		else 
			status = CMCReadXilinxI2CIOM1DataOneTime(device_address, 0, 2, i2c_data);
		if (status == 0)
		   printf("***** Found the device: 0x%x\n", device_address);
		printf("\n");
	}
	return 0;
}

void ReleaseHAPISemaphores()
{
	booln done1 = FALSE;
	int Cmd;
	char junk[80];

	release_hapi_semaphores();
	printf("All semaphores in HAPI are released.\n");

}

void ProcessI2CBusScan()
{
	booln done1 = FALSE;
	int Cmd;
	char junk[80];

    while(!done1)
    {
	printf("\nCMC Watch Dog Functions:\n");
	printf("0 = IOM 1 Bus Scan           1 = IOM 2 Bus Scan\n");
	printf("2 = KVM Bus Scan             3 = PSU 1 Bus Scan\n");
	printf("4 = PSU 2 Bus Scan\n");
	printf("x = exit\n");
	printf("Input Command Character - ");
			// chl
	scanf("%s", junk);
	Cmd = tolower(junk[0]);
	printf("\n");
	printf("\n\n");
	if(Cmd == 'x')
	{
		done1 = TRUE;
	}
	else
	{
		switch(Cmd)
		{
			case '0':
			break;
			case '1':
			break;
			case '2':
			break;
			case '3':
			break;
			case '4':
			break;
			case '5':
			break;
		}
	}
    }
}

void dumpstats(void)
{
	int i, handle, status;
	int ioctls[] = {
		IOCTL_GET_BLADE_INTR_QUEUE,
		IOCTL_GET_FAN_INTR_QUEUE,
		IOCTL_GET_IOM_INTR_QUEUE,
		IOCTL_GET_PSU_INTR_QUEUE,
		IOCTL_GET_CP_INTR_QUEUE,
		IOCTL_GET_KVM_INTR_QUEUE,
		IOCTL_GET_SHIFTY_INTR_QUEUE
	};
#define NUM_QUEUES sizeof(ioctls)/sizeof(int)
	char *types[] = {
		"Blade",
		"Fan",
		"IOM",
		"PSU",
		"CP",
		"KVM",
		"Shifty"
	};
	struct intr_status_t sp[1];
	struct psu_intr_status_t psu_sp[1];

	if ((handle = open( "/dev/GpioDev", O_RDWR)) < 0) {
		printf("%s: Can't open the GPIO device.", __FUNCTION__);
		return;
	}
	printf("===== driver interrupt fifos \n");
	printf("\ttype\tfifo\twatermk\tovrflow\trcv\tsent\n");
	for (i = 0; i < NUM_QUEUES; i++) {
		status = ioctl(
			handle, // Handle to device
			ioctls[i],
			sp);
		if (status != 0) {
			printf("%s, IOCTL_GET_INTR_QUEUE failed, status: 0x%x",
				__FUNCTION__, status);
			continue;
		}
		printf("\t%s\t%d\t%d\t%d\t%d\t%d\n",
			types[i], sp->fifosize, sp->watermark,
			sp->overflows, sp->incnt, sp->outcnt);
	}
	printf("\n");
	printf("Details of PSU Interrupts \n");
	printf("\tEPP\tPSU1\tPSU2\tPSU3\tPSU4\tPSU5\tPSU6\n");
	status = ioctl(
			handle, // Handle to device
			IOCTL_GET_PSU_INTR_QUEUE,
			psu_sp);
		if (status != 0) {
			printf("%s, IOCTL_GET_INTR_QUEUE failed, status: 0x%x",
				__FUNCTION__, status);
		}
	for(i=0 ; i <7;i++)
	{
		printf("\t%d",psu_sp->psu_in_count[i]);
	}
	close(handle);
	printf("\n");

	hapidumpstats();
}

// Print out blade status and control register values.
void dump_blade_regs( void )
{
    int slot, status, cstatus, rc;

    printf("\nBlade Slot   Status   Control\n");
    printf(  "----------   ------   -------\n");

    for (slot = 1; slot <= CMC_MAX_BLADE_SLOTS; slot++) {
        rc = CMCReadBladeStatus(slot, &status);
        if (0 == rc) {
            rc = CMCReadBladeControlStatus(slot, &cstatus);
        }
        if (0 == rc) {
            printf("%10d     %04X      %04X\n", slot, status, cstatus);
        } else {
            printf("%10d     Error: %d\n", slot, rc);
        }
    }

}

void MainMenu(GPIODeviceStruct *pGpioDevice)
{

	GPIOCmdMenu(pGpioDevice);

} // MainMenu 
