/*
 * (C) Copyright 2006
 * Stefan Roese, DENX Software Engineering, sr@denx.de.
 *
 * (C) Copyright 2006
 * Jacqueline Pira-Ferriol, AMCC/IBM, jpira-ferriol@fr.ibm.com
 * Alain Saurel,            AMCC/IBM, alain.saurel@fr.ibm.com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/************************************************************************
 * cmc_10g.h - configuration for CMC 10th gerneration (PowerPC440EPx)
 ***********************************************************************/
#ifndef __CONFIG_H
#define __CONFIG_H


#define CFG_DRAM_TEST 1
//#define DEBUG 1

#define CFG_DEBUG_POST	1

#define DYNAMIC_IMAGE_START 1

#define CONFIG_SILENT_CONSOLE 1
#define CONFIG_ENV_OVERWRITE  1 /*give ability to change the MAC's*/

/*-----------------------------------------------------------------------
 * High Level Configuration Options
 *----------------------------------------------------------------------*/
/* This config file is used for Sequoia (440EPx) and Rainier (440GRx) */
//#ifndef CONFIG_RAINIER
//HACK #define CONFIG_SEQUOIA		1		/* Board is Sequoia	*/
//#define CONFIG_CMC_10G		1		/* board is cmc_10g*/
//#define CONFIG_440EPX		1		/* Specific PPC440EPx	*/
//#else
//#define CONFIG_440GRX		1		/* Specific PPC440GRx	*/
//#endif
//#define CONFIG_4xx		1		/* ... PPC4xx family	*/ 
#define CONFIG_SYS_CLK_FREQ	33333333	/* external freq to pll	*/
#define CONFIG_PHY_CLK_FREQ  EMAC_STACR_CLK_83MHZ /*83Mhz OPB clk*/

#define CONFIG_BOARD_EARLY_INIT_F	1	/*Call board_early_init_f */
#define CONFIG_MISC_INIT_R			1	/*Call misc_init_r	*/
#define CONFIG_LAST_STAGE_INIT		1	/*Call CMC self test*/

/*-----------------------------------------------------------------------
 * Base addresses -- Note these are effective addresses where the
 * actual resources get mapped (not physical addresses)
 *----------------------------------------------------------------------*/
#define CFG_MONITOR_LEN		(512 * 1024)	/* Reserve 512 kB for Monitor	*/
#define CFG_MALLOC_LEN		(1024 * 1024)	/* Reserve 1MB for malloc()	*/

#define CFG_BOOT_BASE_ADDR	0xf0000000	/*TLB entry*/
#define CFG_SDRAM_BASE		0x00000000	/* _must_ be 0		*/
#define CFG_FLASH_BASE		0xffc00000	/* start of FLASH	*/
#define CFG_MONITOR_BASE	TEXT_BASE

#define CFG_FPGA_BASE		0xa0000000	/*TLB entry*/

#define CFG_NAND_ADDR		0xd0000000      /* NAND Flash		*/
#define CFG_OCM_BASE		0xe0010000      /* ocm			*/
#define CFG_PCI_BASE		0xe0000000      /* Internal PCI regs	*/
#define CFG_PCI_MEMBASE		0x80000000	/* mapped pci memory	*/
#define CFG_PCI_MEMBASE1	CFG_PCI_MEMBASE  + 0x10000000
#define CFG_PCI_MEMBASE2	CFG_PCI_MEMBASE1 + 0x10000000
#define CFG_PCI_MEMBASE3	CFG_PCI_MEMBASE2 + 0x10000000

/* Don't change either of these */
#define CFG_PERIPHERAL_BASE	0xef600000	/* internal peripherals	*/

#define CFG_USB2D0_BASE		0xe0000100
#define CFG_USB_DEVICE		0xe0000000
#define CFG_USB_HOST		0xe0000400
#define CFG_BCSR_BASE		0xc0000000	/*EBC TLB */

/*-----------------------------------------------------------------------
 * Initial RAM & stack pointer
 *----------------------------------------------------------------------*/
/* 440EPx/440GRx have 16KB of internal SRAM, so no need for D-Cache	*/
#define CFG_INIT_RAM_OCM	1		/* OCM as init ram	*/
#define CFG_INIT_RAM_ADDR	CFG_OCM_BASE	/* OCM			*/

#define CFG_INIT_RAM_END	(4 << 10)
#define CFG_GBL_DATA_SIZE	256		/* num bytes initial data */
#define CFG_GBL_DATA_OFFSET	(CFG_INIT_RAM_END - CFG_GBL_DATA_SIZE)
#define CFG_INIT_SP_OFFSET	CFG_GBL_DATA_OFFSET

/*-----------------------------------------------------------------------
 * Serial Port
 *----------------------------------------------------------------------*/
//HACK #define CFG_EXT_SERIAL_CLOCK	11059200	/* ext. 11.059MHz clk	*/
#define CONFIG_BAUDRATE		115200		/*change also DEFAULT_BAUDRATE*/
#define CONFIG_SERIAL_MULTI     1
/* define this if you want console on UART1 */
#undef CONFIG_UART1_CONSOLE


#define CFG_BAUDRATE_TABLE						\
	{300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200}

/*-----------------------------------------------------------------------
 * Environment
 *----------------------------------------------------------------------*/
#if !defined(CONFIG_NAND_U_BOOT) && !defined(CONFIG_NAND_SPL)
#define CFG_ENV_IS_IN_FLASH     1	/* use FLASH for environment vars	*/
#else
#define CFG_ENV_IS_IN_NAND	1	/* use NAND for environment vars	*/
#endif

/*-----------------------------------------------------------------------
 * FLASH related
 *----------------------------------------------------------------------*/
#define CFG_FLASH_CFI				/* The flash is CFI compatible	*/
#define CFG_FLASH_CFI_DRIVER		/* Use common CFI driver	*/
#define CFG_FLASH_BANKS_LIST	{ CFG_FLASH_BASE }
#define CFG_MAX_FLASH_BANKS	1	/* max number of memory banks		*/

#define CFG_SECT_SIZE		0x10000	
#define FLASH_SECTOR_SIZE	CFG_SECT_SIZE	/*image tool compatability*/

#define CFG_FLASH_START_SECT	0
#define CFG_FLASH_END_SECT		70
#define CFG_MAX_FLASH_SECT		71	/* max number of sectors on one chip	*/
#define CFG_FLASH_LAST_64K_SECT 62
#define CFG_FLASH_1ST_8K_SECT	63
#define CFG_FLASH_8K_BASE       ((CFG_FLASH_1ST_8K_SECT * CFG_SECT_SIZE) \
								+ CFG_FLASH_BASE)
#define CFG_SECT_SIZE_8K		0x00002000
#define CFG_FLASH_NOR_SIZE		0x00400000	/*4Meg*/

#define CFG_FLASH_ERASE_TOUT	120000	/* Timeout for Flash Erase (in ms)	*/
#define CFG_FLASH_WRITE_TOUT	500	/* Timeout for Flash Write (in ms)	*/

#define CFG_FLASH_USE_BUFFER_WRITE 1	/* use buffered writes (20x faster)	*/
#define CFG_FLASH_PROTECTION	1	/* use hardware flash protection	*/

/*	U-Boot bug, see drivers/cfi_flash.c  flash_get_size()*/
#define CFG_FLASH_TOP_BOOT_ONLY	1
#define CFG_FLASH_EMPTY_INFO		/* print 'E' for empty sector on flinfo */



#if 0 /*origional*/
#ifdef CFG_ENV_IS_IN_FLASH
#define CFG_ENV_SECT_SIZE	0x10000 	/* size of one complete sector	*/
#define CFG_ENV_ADDR		((-CFG_MONITOR_LEN)-CFG_ENV_SECT_SIZE)
#define	CFG_ENV_SIZE		0x2000	/* Total Size of Environment Sector	*/
/* Address and size of Redundant Environment Sector	*/
#define CFG_ENV_ADDR_REDUND	(CFG_ENV_ADDR-CFG_ENV_SECT_SIZE)
#define CFG_ENV_SIZE_REDUND	(CFG_ENV_SIZE)
#endif

#else	/*New ENV area changes. Please reference util_flashmap.h*/

#ifdef CFG_ENV_IS_IN_FLASH
#define CFG_ENV_SECT_SIZE	0x10000 	/*size of one complete sector*/
							/*See FLASH_SECT_START_ENV in util_flashmap.h*/
#define CFG_ENV_ADDR		0xFFEA0000  
#define	CFG_ENV_SIZE		0x10000		/*Total Size of Environment Sector*/

/* Address and size of Redundant Environment Sector	*/
#define CFG_ENV_ADDR_REDUND	(CFG_ENV_ADDR-CFG_ENV_SECT_SIZE)
#define CFG_ENV_SIZE_REDUND	(CFG_ENV_SIZE)
#endif 

#endif /*end origional*/

/*
 * IPL (Initial Program Loader, integrated inside CPU)
 * Will load first 4k from NAND (SPL) into cache and execute it from there.
 *
 * SPL (Secondary Program Loader)
 * Will load special U-Boot version (NUB) from NAND and execute it. This SPL
 * has to fit into 4kByte. It sets up the CPU and configures the SDRAM
 * controller and the NAND controller so that the special U-Boot image can be
 * loaded from NAND to SDRAM.
 *
 * NUB (NAND U-Boot)
 * This NAND U-Boot (NUB) is a special U-Boot version which can be started
 * from RAM. Therefore it mustn't (re-)configure the SDRAM controller.
 *
 * On 440EPx the SPL is copied to SDRAM before the NAND controller is
 * set up. While still running from cache, I experienced problems accessing
 * the NAND controller.	sr - 2006-08-25
 */
#define CFG_NAND_BOOT_SPL_SRC	0xfffff000	/* SPL location			*/
#define CFG_NAND_BOOT_SPL_SIZE	(4 << 10)	/* SPL size			*/
#define CFG_NAND_BOOT_SPL_DST	(CFG_OCM_BASE + (12 << 10)) /* Copy SPL here	*/
#define CFG_NAND_U_BOOT_DST	0x01000000	/* Load NUB to this addr	*/
#define CFG_NAND_U_BOOT_START	CFG_NAND_U_BOOT_DST /* Start NUB from this addr	*/
#define CFG_NAND_BOOT_SPL_DELTA	(CFG_NAND_BOOT_SPL_SRC - CFG_NAND_BOOT_SPL_DST)

/*
 * Define the partitioning of the NAND chip (only RAM U-Boot is needed here)
 */
#define CFG_NAND_U_BOOT_OFFS	(16 << 10)	/* Offset to RAM U-Boot image	*/
#define CFG_NAND_U_BOOT_SIZE	(384 << 10)	/* Size of RAM U-Boot image	*/

/*
 * Now the NAND chip has to be defined (no autodetection used!)
 */
//#define CFG_NAND_PAGE_SIZE	(512)		/* NAND chip page size		*/
//#define CFG_NAND_BLOCK_SIZE	(16 << 10)	/* NAND chip block size		*/
//#define CFG_NAND_PAGE_COUNT	(32)		/* NAND chip page count		*/
#define CFG_NAND_PAGE_SIZE	(2048)		/* NAND chip page size		*/
#define CFG_NAND_BLOCK_SIZE			0x00020000	/* NAND chip block size		*/
#define CFG_NAND_BLOCK_SIZE_MASK	0x0001ffff	/* NAND chip block size	mask*/
#define CFG_NAND_PAGE_COUNT	(64)		/* NAND chip page count		*/

#define CFG_NAND_BAD_BLOCK_POS	(5)		/* Location of bad block marker	*/
#undef CFG_NAND_4_ADDR_CYCLE			/* No fourth addr used (<=32MB)	*/

#if 0	
/*
*	Add for JFFS2 support needed to read update image file
*	ls/fsload was soooooo slow, forget it. The docs have the following defines
*	but in the code NAND does not seem to be defined. I never got the offset
*	to work yet.
*/
#define CONFIG_JFFS2_NAND 1						/*NAND does not seem to be defined*/
#define CONFIG_JFFS2_NAND_DEV	0			    /*nand device jffs2 lives on*/
#define CONFIG_JFFS2_NAND_OFF	0x04600000		/*start of jffs2 partition*/
#define CONFIG_JFFS2_NAND_SIZE	58*1024*1024	/*size of jffs2 partition*/

#define CONFIG_JFFS2_CMDLINE 1
#define CONFIG_JFFS2_DEV	"nand0"			/*nand device jffs2 lives on*/
#define CONFIG_JFFS2_OFF	0x04600000		/*start of jffs2 partition*/
#define CONFIG_JFFS2_SIZE	58*1024*1024	/*size of jffs2 partition*/
#endif



/*HACK temp find some parameter in the info struct to use. */
#define CFG_FLASH_START_BLOCK	0
#define CFG_FLASH_END_BLOCK		1023	
#define CFG_FLASH_TOTAL_BLOCKS	1024
#define CFG_FLASH_NAND_SIZE		(CFG_NAND_BLOCK_SIZE * (CFG_FLASH_END_BLOCK+1))
#define CFG_NAND_TOTAL_PAGES	(CFG_NAND_PAGE_COUNT * CFG_FLASH_TOTAL_BLOCKS)


#ifdef CFG_ENV_IS_IN_NAND
/*
 * For NAND booting the environment is embedded in the U-Boot image. Please take
 * look at the file board/amcc/sequoia/u-boot-nand.lds for details.
 */
#define CFG_ENV_SIZE		CFG_NAND_BLOCK_SIZE
#define CFG_ENV_OFFSET		(CFG_NAND_U_BOOT_OFFS + CFG_ENV_SIZE)
#define CFG_ENV_OFFSET_REDUND	(CFG_ENV_OFFSET + CFG_ENV_SIZE)
#endif

/*-----------------------------------------------------------------------
 * DDR SDRAM
 *----------------------------------------------------------------------*/
#define CFG_MBYTES_SDRAM        (256)    /* 256MB			*/
#define CFG_KBYTES_SDRAM        (CFG_MBYTES_SDRAM * 1024) 

/*-----------------------------------------------------------------------
 * I2C
 *----------------------------------------------------------------------*/
#define CONFIG_HARD_I2C		1		/* I2C with hardware support	*/
#undef	CONFIG_SOFT_I2C				/* I2C bit-banged		*/
#define CFG_I2C_SPEED		100000		/* I2C speed and slave address	*/
#define CFG_I2C_SLAVE		0x7F
#define CFG_I2C1_SPEED		400000		/* BLR - 10G CP needs 400KHz I2c */
#define CFG_I2C1_SLAVE		0x7F		/* BLR - Added for compatibility */
#define CONFIG_I2C_CMD_TREE			/* BLR - Add support for new I2C command*/
#define CONFIG_I2C_MULTI_BUS			/* BLR - Add support for multiple I2C Busses*/


#define CFG_I2C_MULTI_EEPROMS
#define CFG_I2C_EEPROM_ADDR	(0xa8>>1)
#define CFG_I2C_EEPROM_ADDR_LEN 1
#define CFG_EEPROM_PAGE_WRITE_ENABLE
#define CFG_EEPROM_PAGE_WRITE_BITS 3
#define CFG_EEPROM_PAGE_WRITE_DELAY_MS 10

/* I2C SYSMON (LM75, AD7414 is almost compatible)			*/
#define CONFIG_DTT_LM75		1		/* ON Semi's LM75	*/
/* CMC LM75, need to bump sensor from 0->1, in order to bump addr from 48->49*/
#define CONFIG_DTT_SENSORS	{1}		/* Sensor addresses	*/
#define CFG_DTT_MAX_TEMP	70
#define CFG_DTT_LOW_TEMP	-30
#define CFG_DTT_HYSTERESIS	3



#if 0 /*leave as a place holder, we might need to add a test msg later*/
#define CONFIG_PREBOOT	"echo;"										 \
	"echo Type \"run flash_nfs\" to mount root filesystem over NFS;" \
	"echo"
#else
#define CONFIG_PREBOOT	"echo;"	
#endif



#undef	CONFIG_BOOTARGS

#define	CONFIG_EXTRA_ENV_SETTINGS						\
	"bootcmd=run flash_self\0"							\
 	"netdev=eth0\0"										\
	"netretry=no\0"										\
	"hostname=cmc\0"									\
	"console=ttyS0\0"									\
	"nfsargs=setenv bootargs root=/dev/nfs rw "			\
	"nfsroot=${serverip}:${rootpath}\0"					\
	"ramargs=setenv bootargs root=/dev/ram rw\0"		\
	"addip=setenv bootargs ${bootargs} "				\
	"ip=${ipaddr}:${serverip}:${gatewayip}:${netmask}"	\
	":${hostname}:${netdev}:off panic=1\0"				\
	"addtty=setenv bootargs ${bootargs} console=${console},${baudrate}\0"\
	"flash_nfs=run nfsargs addip addtty;"				\
	"bootm ${kernel_addr}\0"							\
	"flash_self=run ramargs addip addtty;"				\
	"bootm ${kernel_addr} ${ramdisk_addr}\0"			\
	"net_nfs=tftp 200000 ${bootfile};run nfsargs addip addtty;"     \
	"bootm\0"											\
	"rootpath=/cmcproto/cmc_src/cmc_image/dell_64/rootfs\0"			\
	"bootfile=uImage\0"		\
	"kernel_addr=FE000000\0"							\
	"ramdisk_addr=FE180000\0"							\
	"load=tftp 200000 u-boot.bin\0"						\
	"update=protect off FFF80000 FFFFFFFF;era FFF80000 FFFFFFFF;"	\
	"cp.b 200000 FFF80000 80000; setenv filesize; saveenv\0"		\
	"upd=run load;run update\0"							\
	"serverip=192.168.0.100\0"							\
	"gatewayip=192.168.0.1\0"							\
	"netmask=255.255.255.0\0"							\
	"ipaddr=192.168.0.120\0"							\
	"ethprime=ppc_4xx_eth0\0"							\
	"bootargs=root=/dev/nfs rw nfsroot=192.168.0.100:/cmcproto/rootfs" \
	"ip=192.168.0.120:192.168.0.121:192.168.0.1::sequoia:eth1:on panic=1" \
	" console=ttyS0,115200\0"							\
	"erasefwImage=nand erase clean 4600000\0"			\
	"erasevar=nand erase clean 3a00000 4600000\0"		\
	"flashfwImage=nand write.jffs2 200000 4600000 ${filesize}\0" \
	"flashvar=nand write.jffs2 200000 3a00000 ${filesize}\0" \
	"loadfwImage=tftp 200000 fwImage.bin\0"				\
	"loadvar=tftp 200000 var.jffs2\0"					\
	"eraserootfs=nand erase clean 200000 3a00000\0"		\
	"eraseuImage=nand erase clean 0 200000\0"			\
	"flashrootfs=nand write.jffs2 200000 200000 ${filesize}\0"	\
	"flashuImage=nand write.jffs2 200000 0 ${filesize}\0"		\
	"linux=run loadnand nandargs addip addtty;bootm\0"	\
	"loadnand=nboot 200000 uImage\0"					\
	"loadrootfs=tftp 200000 rootfs.jffs2\0"				\
	"loaduImage=tftp 200000 uImage\0"					\
	"nandargs=setenv bootargs root=/dev/mtdblock1 rw rootfstype=jffs2\0" \
	"upn=run eraseuImage eraserootfs loaduImage flashuImage loadrootfs"  \
	" flashrootfs\0" \
	"ethact=ppc_4xx_eth0\0"								\
	""

/*
*	Make defaults for bootargs created in cmc_10g.c, last_stage_init()
*	These should never be needed as the env variables should exists.
*	Do NO add them to environment.c as we want to allow the user to change them
*/
#define DEFAULT_SERVERIP	"serverip=192.168.0.100"
#define DEFAULT_GATEWAYIP	"gatewayip=192.168.0.1"
#define DEFAULT_NETMASK		"netmask=255.255.255.0"
#define DEFAULT_IPADDR		"ipaddr=192.168.0.120"
#define DEFAULT_HOSTNAME	"cmc"
#define DEFAULT_NETDEV		"netdev=eth0"
#define DEFAULT_CONSOLE		"ttyS0"
#define DEFAULT_BAUDRATE	"115200"	/*change also CONFIG_BAUDRATE*/


#define CONFIG_BOOTCOMMAND	"nboot 200000 uImage; bootm"
#define CONFIG_BOOTDELAY	10	/*autoboot in 10sec vendor mode only*/

#define CONFIG_LOADS_ECHO	1	/* echo on for serial download	*/
#define CFG_LOADS_BAUD_CHANGE	1	/* allow baudrate change	*/

#define CONFIG_M88E1111_PHY	1
#define	CONFIG_IBM_EMAC4_V4	1
#define CONFIG_MII		1	/* MII PHY management		*/
/*	DF146282 Was 0x19, change to 0x1a, port 1 is left most on silkscreen*/
#define CONFIG_PHY_ADDR		0x1A	/* PHY address, See schematics	*/

#define CONFIG_PHY_RESET        1	/* reset phy upon startup         */
#define CONFIG_PHY_GIGE		1	/* Include GbE speed/duplex detection */

#define CONFIG_HAS_ETH0
#define CFG_RX_ETH_BUFFER	32	/* Number of ethernet rx buffers & descriptors */

#define CONFIG_NET_MULTI	1
#define CONFIG_HAS_ETH1		1	/* add support for "eth1addr"	*/
#define CONFIG_PHY1_ADDR	3

/* USB */
#ifdef CONFIG_440EPX
#define CONFIG_USB_OHCI
#define CONFIG_USB_STORAGE

/* Comment this out to enable USB 1.1 device */
#define USB_2_0_DEVICE

#define CMD_USB			CFG_CMD_USB
#else
#define CMD_USB			0	/* no USB on 440GRx		*/
#endif /* CONFIG_440EPX */

/* Partitions */
#define CONFIG_MAC_PARTITION
#define CONFIG_DOS_PARTITION
#define CONFIG_ISO_PARTITION

#define CONFIG_COMMANDS       (CONFIG_CMD_DFL	|	\
			       CFG_CMD_ASKENV	|	\
			       CFG_CMD_DHCP	|	\
			       CFG_CMD_DTT	|	\
			       CFG_CMD_DIAG	|	\
			       CFG_CMD_EEPROM	|	\
			       CFG_CMD_ELF	|	\
			       CFG_CMD_FAT	|	\
			       CFG_CMD_I2C	|	\
			       CFG_CMD_IRQ	|	\
			       CFG_CMD_MII	|	\
			       CFG_CMD_NAND	|	\
			       CFG_CMD_NET	|	\
			       CFG_CMD_NFS	|	\
			       CFG_CMD_PING	|	\
			       CFG_CMD_REGINFO	|	\
			       CFG_CMD_SDRAM	|	\
				   CFG_CMD_JFFS2	|	\
			       CMD_USB)

#define CONFIG_SUPPORT_VFAT

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

/*-----------------------------------------------------------------------
 * Miscellaneous configurable options
 *----------------------------------------------------------------------*/
#define CFG_LONGHELP			/* undef to save memory		*/
#define CFG_PROMPT	        "=> "	/* Monitor Command Prompt	*/
#define CMC_PROMPT_MAX_LEN	20
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CBSIZE	        1024	/* Console I/O Buffer Size	*/
#else
/*Console I/O Buffer Size, 256 causes util help errors	*/
#define CFG_CBSIZE	        1024
#endif
#define CFG_PBSIZE              (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define CFG_MAXARGS	        16	/* max number of command args	*/
#define CFG_BARGSIZE	        CFG_CBSIZE /* Boot Argument Buffer Size	*/

#define CFG_MEMTEST_START	0x0400000 /* memtest works on		*/
#define CFG_MEMTEST_END		0x0C00000 /* 4 ... 12 MB in DRAM	*/

#define CFG_LOAD_ADDR		0x00200000  /* default load address	*/
#define CFG_MEMTEST_START_FLASH_EXE		0x00000000
#define CFG_MEMTEST_END_FLASH_EXE		0x10000000
#define CFG_MEMTEST_START_RAM_EXE		CFG_LOAD_ADDR
#define CFG_MEMTEST_END_RAM_EXE			0x0f600000	/*10Meg from the top*/

#define CONFIG_PRAM			1024	/* reserve 1 MB "protected RAM" */
#define CFG_EXTBDINFO		1		/* To use extended board_into (bd_t) */

#define CFG_HZ		        1000	/* decrementer freq: 1 ms ticks	*/

#define CONFIG_CMDLINE_EDITING	1	/* add command line history	*/
#define CONFIG_LOOPW            1       /* enable loopw command         */
#define CONFIG_MX_CYCLIC        1       /* enable mdc/mwc commands      */
#define CONFIG_ZERO_BOOTDELAY_CHECK	/* check for keypress on bootdelay==0 */
#define CONFIG_VERSION_VARIABLE 1	/* include version env variable */

/*-----------------------------------------------------------------------
 * PCI stuff
 *----------------------------------------------------------------------*/
/* General PCI */
//#define CONFIG_PCI			/* include pci support	        */
#undef CONFIG_PCI			/* include pci support	        */

//#define CONFIG_PCI_PNP			/* do (not) pci plug-and-play   */
//#define CONFIG_PCI_SCAN_SHOW		/* show pci devices on startup  */
#define CFG_PCI_TARGBASE        0x80000000 /* PCIaddr mapped to CFG_PCI_MEMBASE*/

/* Board-specific PCI */
//#define CFG_PCI_PRE_INIT		/* enable board pci_pre_init()	*/
//#define CFG_PCI_TARGET_INIT
//#define CFG_PCI_MASTER_INIT

#define CFG_PCI_SUBSYS_VENDORID 0x10e8	/* AMCC				*/
#define CFG_PCI_SUBSYS_ID       0xcafe	/* Whatever			*/

/*
 * For booting Linux, the board info and command line data
 * have to be in the first 8 MB of memory, since this is
 * the maximum mapped by the Linux kernel during initialization.
 */
#define CFG_BOOTMAPSZ		(8 << 20)	/* Initial Memory map for Linux */

/*-----------------------------------------------------------------------
 * External Bus Controller (EBC) Setup
 *----------------------------------------------------------------------*/
#define CFG_FLASH		CFG_FLASH_BASE
#define CFG_NAND		CFG_NAND_ADDR
#define CFG_FPGA		CFG_FPGA_BASE

/*
 * On Sequoia CS0 and CS3 are switched when configuring for NAND booting
 */
/*	u-boot/cpu/ppc4xx/cpu_init.c*/
#if !defined(CONFIG_NAND_U_BOOT) && !defined(CONFIG_NAND_SPL)

/* Memory Bank 0 (NOR-FLASH) initialization					*/
//HACK #define CFG_EBC_PB0AP		0x03017300				/*sequoia*/
#define CFG_EBC_PB0AP		0x0383fe00  
//HACK #define CFG_EBC_PB0CR		(CFG_FLASH | 0xba000)	/*sequoia*/
#define CFG_EBC_PB0CR		(CFG_FLASH | 0x5a000)


/* Memory Bank 1 (FPGA) initialization					*/
//HACK FOR TIM #define CFG_EBC_PB1AP		0x04055400
#define CFG_EBC_PB1AP		0x06055600
#define CFG_EBC_PB1CR		(CFG_FPGA | 0x1a000)


/* Memory Bank 2 (NAND-FLASH) initialization*/	
#define CFG_NAND_CS			2		
#define CFG_EBC_PB2AP		0x018003c0
#define CFG_EBC_PB2CR		(CFG_NAND | 0x1c000)





#else
#define CFG_NAND_CS		0		/* NAND chip connected to CSx	*/
/* Memory Bank 3 (NOR-FLASH) initialization					*/
#define CFG_EBC_PB3AP		0x03017300
#define CFG_EBC_PB3CR		(CFG_FLASH | 0xba000)

/* Memory Bank 0 (NAND-FLASH) initialization					*/
#define CFG_EBC_PB0AP		0x018003c0
#define CFG_EBC_PB0CR		(CFG_NAND | 0x1c000)
#endif


/*-----------------------------------------------------------------------
 * NAND FLASH
 *----------------------------------------------------------------------*/
#define CFG_MAX_NAND_DEVICE	1
#define NAND_MAX_CHIPS		1
#define CFG_NAND_BASE		(CFG_NAND_ADDR + CFG_NAND_CS)
/*
*	The CMC uses chip select 2 for the NAND. If CFG_NAND_SELECT_DEVICE is
*	defined In file nand.c, func nand_init(), there is a second call to
*	board_nand_select_device() that messes up the chip select and makes
*	it 0.  CMC only has one NAND so comment this out.
*/
/*  #define CFG_NAND_SELECT_DEVICE  1	 nand driver supports mutipl. chips	*/

/*-----------------------------------------------------------------------
 * Cache Configuration
 *----------------------------------------------------------------------*/
#define CFG_DCACHE_SIZE		(32<<10)  /* For AMCC 440 CPUs			*/
#define CFG_CACHELINE_SIZE	32	      /* ...			            */
#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CFG_CACHELINE_SHIFT	5	      /* log base 2 of the above value	*/
#endif

/*
 * Internal Definitions
 *
 * Boot Flags
 */
#define BOOTFLAG_COLD	0x01		/* Normal Power-On: Boot from FLASH	*/
#define BOOTFLAG_WARM	0x02		/* Software reboot			*/

#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CONFIG_KGDB_BAUDRATE	230400	/* speed to run kgdb serial port */
#define CONFIG_KGDB_SER_INDEX	2	    /* which serial port to use */
#endif
#endif	/* __CONFIG_H */
